/**************************************************************/
/*                                                            */
/*   Program Name :  autoobs2                                 */
/*                                                            */
/*      Version:  0.0   2002-08-15                            */
/*                1.01  2002-08-15                            */
/*                1.10  2002-10-06                            */
/*                                                            */
/*      Copyright (c) 2002 T.Kondo/CRL All Right Reserved     */
/*                                                            */
/**************************************************************/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <sys/stat.h>
#ifdef linux
#include <sys/time.h>
#else
#include <time.h>
#endif
#include <sys/tdsio.h>

#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo)
#include "libipvlbi_board.h"  // IP-VLBITv[{[hp֐Q(by T.Kondo)

#define SLEEP_USEC 10000    // watch dog timer sep (10msec)

#define GET_TIME_FROM_BOARD 1  //  ^p̎{[h瓾邩ob̎瓾邩̔
	                      //  1: {[h    0:ob


/*
ho|ukah@ItCϑO(2000ϑ̃T|[gj
        iZbg͕ʂ̃\tgōsj
         by T.Kondo 2002.8.15  autoobs̊ϑ2000܂Ŋg
	                           уXPW[Ԃ̃f[^LƂȂ悤
	                           PbOɃX^[g

    点@autoobs2 sked_file station_id [span [sfreq [adbit [numch [outdir]]]]]
         Ł@sked_file ---- XPW[t@C
                staion_id ----  ID (XPW[t@CŋLqĂǂhc)
                span ---- ϑ (sec)
                          iXPW[t@CŋK肵Ă
                           ϑԂZړIj
                           ftHg͂POb
                           XPW[t@Cʂ̊ϑԂƂƂ
                           OƂ
                sfreq  TvOg
                       40,100,200,500  (kHz)
                       1,2,4,8,16      (MHz)
                          ftHg16
                adbit  `c\irbg)
                       1,2,4,8
                          ftHg1
                numch  `l
                       1@܂ 4
                          ftHg1
                outdir  f[^t@Co̓fBNg
                          ftHg̓JgfBNg
*/
int main(int argc, char *argv[])
{
       char dev[] = "/dev/tds0";
       char outfile [80];
       char fname [50];
       char outdir [60];
       char* dflt_dir="./";        // default out file directory
       char skdname[80];
       char mystation[11];
       char stat_id[4];
       char cbuf[60];
       char afreq[20];
       char y_or_n[2];
       int fd_in,rv;
       int i, span, sfreq, adbit, numch;
       int nobs, obsspan, fixspan;  
       int year,ddd,hh,mm,ss ;
       int yearf,dddf,hhf,mmf,ssf ;   // to keep 1st obs info
       int yearl,dddl,hhl,mml,ssl ;   // to keep last obs info
       int year1,ddd1,hh1,mm1,ss1 ;   // 
       int year2,ddd2,hh2,mm2,ss2 ;   // 
       int yearn,dddn,hhn,mmn,ssn ;
       int yearPC;  // to keep yaer get from PC
       int month,mday;
       int monthf,mdayf;
       int monthl,mdayl;
       int month1,mday1;
       int month2,mday2;
       int monthn,mdayn;
       int iofset;
       int flagobs;
       unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
       unsigned int secold, sec1st, seclast, secobsst, secobset, secnow, secnext;
       int day1st, daylast, daynow, daynext;
       int  h, m, s;          
       int counter;
       int time_mode;  // ^p̎{[h瓾邩ob̎瓾邩̔
                       //  0: {[h@@@1:ob
       float timeoffset;  //  PCI board time - CPU time label (in sec)
       float tofset, fsec;
       float w1,w2,w3,w4,w5 ;  // work
       double dtime1st,dtimelast,dtimenow, dtimenext, dtimenext2;
       double dtime1, dtime2;  // manually set obs time range
       double d1sec;    // 1sec in day unit
       double dwork;
       static sked_data_t skd;
       d1sec=1.0/86400.0;
       if(argc == 1){
          printf("autoobs Ver.1.10\n");
          printf("Usage: autoobs2 sked_file station_id [span [sfreq [adbit [numch [outdir [y_or_no]]]]]]\n");
          printf("\n");
          printf("         where  sked_file ---- schedule file name\n");
          printf("                staion_id ---- station ID (A1)\n");
          printf("                span ---- duration (sec)\n");
          printf("                          compulsory shorten obs length!\n");
          printf("                          default = 10 (sec)\n");
          printf("                          =0 means no effect\n");
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           1,2,4,8,16 (for MHz)\n");
          printf("                          default is 16\n");
          printf("                adbit ---- A/D bit\n");
          printf("                           1,2,4,8\n");
          printf("                          default is 1\n");
          printf("                numch ---- number of channel\n");
          printf("                           1,4\n");
          printf("                          default is 1\n");
          printf("                outdir ---- output file directory\n");
          printf("                          default is current directory\n");
          printf("                y_or_n ---- Obs range limitation reply N or Y\n");
          printf("                          default is interactively asked later\n");
          exit(0);
       }

       if (argc>=2)
       {
          strcpy(skdname,argv[1]);  
       }

       if (argc>=3)
       {
          strcpy(stat_id,argv[2]);  
       }
       else
       {
          strcpy(stat_id,"G");   // default set to KOGANEI
       }

       if (argc>=4)
       {
           fixspan = atoi(*(argv + 3 ));
       }
       else
       {
          fixspan=10;   // default fix span (sec)
       }

       if (argc>=5)
       {
           sfreq = atoi(*(argv + 4 ));
       }
       else
       {
          sfreq=16;
       }

       if (argc>=6)
       {
           adbit = atoi(*(argv + 5 ));
       }
       else
       {
          adbit=1;
       }

	   if (argc>=7)
       {
          numch = atoi(*(argv + 6 ));
       }
       else
       {
          numch=1;
       }

       if (argc>=8)
       {
          strcpy(outdir,*(argv+7));
       }
       else
       {
          strcpy(outdir,dflt_dir);
       }
       /* check out dir name accompanied by "/" or not */
       i=strlen(outdir);
       //printf("i= %d\n",i);
       if(outdir[i-1] != '/') {
          outdir[i]='/';
          outdir[i+1]='\0';
       }

       if (argc>=9)
       {
          strcpy(y_or_n,*(argv+8));
       }
       else
       {
          strcpy(y_or_n," ");
       }

	time_mode=GET_TIME_FROM_BOARD;  //  current TIME get from IP-VLBI board or not
	//time_mode=0;  //  current TIME get from PC board
	

       printf(" skedname = %s\n",skdname);    // debug
       printf(" station_id = %s\n",stat_id);    // debug
       printf(" span = %d\n",fixspan);    // debug
       printf(" sfreq= %d\n",sfreq);   // debug
       printf(" adbit= %d\n",adbit);   // debug
       printf(" numch= %d\n",numch);   // debug
       printf(" outdir= %s\n",outdir);   // debug
       if(sfreq==40){ strcpy(afreq,"40kHz");}
       else if(sfreq==100){ strcpy(afreq,"100kHz");}
       else if(sfreq==200){ strcpy(afreq,"200kHz");}
       else if(sfreq==500){ strcpy(afreq,"500kHz");}
       else if(sfreq==1){ strcpy(afreq,"1MHz");}
       else if(sfreq==2){ strcpy(afreq,"2MHz");}
       else if(sfreq==4){ strcpy(afreq,"4MHz");}
       else if(sfreq==8){ strcpy(afreq,"8MHz");}
       else if(sfreq==16){ strcpy(afreq,"16MHz");}
       else { strcpy(afreq,"INVALID");}

       /* schedule file read and analysis */

       readskd(skdname, &skd);
       if (skd.nobs <= 0)  { goto exitend ; }

       /* Observation Time Range Check */
       yearf=skd.start[0][0]+2000;
       dddf=skd.start[0][1];
       hhf=skd.start[0][2];
       mmf=skd.start[0][3];
       ssf=skd.start[0][4];
       sec1st=hhf*3600+mmf*60+ssf;
       day1st=dddf;
       printf("day1st  %d\n",day1st);
       dtime1st=day1st+sec1st/86400.0;
       ddd2md(yearf,dddf,&monthf,&mdayf);
       printf("1st  Obseravtion : %04d/%02d/%02d %02d:%02d:%02d  %s\n",yearf,monthf,mdayf,hhf,mmf,ssf,
                      skd.obsstar[0]);
       yearl=skd.start[skd.nobs-1][0]+2000;
       dddl=skd.start[skd.nobs-1][1];
       hhl=skd.start[skd.nobs-1][2];
       mml=skd.start[skd.nobs-1][3];
       ssl=skd.start[skd.nobs-1][4];
       seclast=hhl*3600+mml*60+ssl;
       daylast=dddl;
       dtimelast=daylast+seclast/86400.0;
       ddd2md(yearl,dddl,&monthl,&mdayl);
       printf("Last Obseravtion : %04d/%02d/%02d %02d:%02d:%02d  %s\n",yearl,monthl,mdayl,hhl,mml,ssl,
                      skd.obsstar[skd.nobs-1]);
       // printf("Date range %f -- %f\n",dtime1st,dtimelast);

       dtime1=dtime1st;     dtime2=dtimelast;
       year1=yearf;       year2=yearl;
       ddd1=dddf;       ddd2=dddl;
       month1=monthf;   month2=monthl;
       mday1=mdayf;     mday2=mdayl;
       hh1=hhf;        hh2=hhl;
       mm1=mmf;        mm2=mml;
       ss1=ssf;        ss2=ssl;
       /* Observation range limit if selected so */

       if (strncmp(y_or_n," ",1)==0) { // interactive mode
       strcpy(cbuf,"\0");
       //printf(" Observation Time range Change? (Y/[N]) ----> ");
       printf(" Observation Time range Change? (Y/N) ----> ");
       scanf("%s",&cbuf);
       if(strncmp(cbuf,"Y",1)==0 || strncmp(cbuf,"y",1)==0 ){
            year1=yearf;
            printf("Enter Start Time (month mday hour min sec)\n");
            scanf("%d %d %d %d %d", &month1,&mday1,&hh1,&mm1,&ss1);
            md2ddd(year1,&ddd1,month1,mday1);
            secnow=hh1*3600+mm1*60+ss1;
            dtime1=(double)ddd1+secnow/86400.0;
            printf("Enter Stop  Time (month mday hour min sec)\n");
            scanf("%d %d %d %d %d", &month2,&mday2,&hh2,&mm2,&ss2);
            md2ddd(year1,&ddd2,month2,mday2);
            secnow=hh2*3600+mm2*60+ss2;
            dtime2=(double)ddd2+secnow/86400.0;
            printf("dtime1 dtime2 %f %f\n)",dtime1,dtime2);
       }
       } else if(strncmp(y_or_n,"Y",1)==0){
            year1=yearf;
            printf("Enter Start Time (month mday hour min sec)\n");
            scanf("%d %d %d %d %d", &month1,&mday1,&hh1,&mm1,&ss1);
            md2ddd(year1,&ddd1,month1,mday1);
            secnow=hh1*3600+mm1*60+ss1;
            dtime1=(double)ddd1+secnow/86400.0;
            printf("Enter Stop  Time (month mday hour min sec)\n");
            scanf("%d %d %d %d %d", &month2,&mday2,&hh2,&mm2,&ss2);
            md2ddd(year1,&ddd2,month2,mday2);
            secnow=hh2*3600+mm2*60+ss2;
            dtime2=(double)ddd2+secnow/86400.0;
            printf("dtime1 dtime2 %f %f\n)",dtime1,dtime2);
       }
       	    


       /* station select if Station is not yet selected */

       if (argc<=2)
       {
          printf(" ****** STATION ID TABLE *********\n");
          for (i=0; i<skd.nstation ; i++)
          {
             printf("  %s --- %s\n",skd.statid[i],skd.statnam[i]);
          }
          printf(" *********************************\n");
          printf(" Enter Station ID ----> ");
          scanf("%s",&stat_id);
          printf(" Selected station_id is %s\n",stat_id);
       }
       /* Set Up my station Name */
       strcpy(mystation,"\0");
       for (i=0; i<skd.nstation ; i++)
       {
           if (strncmp(skd.statid[i],stat_id,1)==0)
           {
                //strncpy(mystation,skd.statnam[i],strlen(skd.statnam[i]));
                strcpy(mystation,skd.statnam[i]);
                printf("  %s --- %s\n",stat_id,mystation);
           }
       }


        /* Board Time and System Time Check and offset get */
        iofset=0;
        tofset=0.0;
 
        fd_in = open("/dev/tds0", O_RDONLY);  //foCX̃I[v
        if (fd_in == -1) {
            perror("device open() error ");
            return -1;
        }
        //foCX玞̎擾 and display while
        secold=100000;
        counter=0;

        do{
           rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
           if (rv == -1) 
           {
              perror("ioctl() time get failed ");
              return -1;
           }
           day=TDS_GET_DAYS(time);
           sec=TDS_GET_SEC(time);
           if (sec!=secold)        // to catch exact second tic
           {
              sec2hms(sec,&h,&m,&s);
              printf("%03d %02d:%02d:%02d\n",day,h,m,s);
              if (counter >=1 ) { goto exith1 ;}
              counter++; 
           }
           secold=sec;
        }while(counter <=10);
        exith1:

        //iofset=0;
        //tofset=0.0;
        //getsystime(&year, &month, &mday, &hh, &mm, &ss, &iofset);
        getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
        tofset=(float)sec-((float)(hh*3600+mm*60+ss)+fsec); 
        //iofset=sec-(hh*3600+mm*60+ss);
        printf("System Time : %04d/%02d/%02d %02d:%02d:%02d\n",year,month,mday,hh,mm,ss);
        printf("Offset %f\n",tofset);
        yearPC=year;  // year info get from PC save
        //printf("Offset %d\n",iofset);

        close(fd_in);  // ho|ukah{[hN[Y


        /* Schedule Time Check */
        /* wait till next obs */
       
        nobs=0;

 obsloop:
       secold=90000;

       printf("\033[2J");   //  Erase the screen ( move the cursor to home ) for VT100
       printf("\033[H");   //  move the cursor to home
       printf("*****************************************************************\n");
       printf("*                                                               *\n");
       printf("*  AUTOOBS2  (Automatic observation program for IP-VLBI board)  *\n");
       printf("*            (Ver 1.10    2002-10-06   T.Kondo/CRL)             *\n");
       printf("*                                                               *\n");
       if(time_mode==1){
       printf("*         Time for scheduling Get from IP-Board                 *\n");
       } else {
       printf("*         Time for scheduling Get from PC                       *\n");
       }
       printf("*****************************************************************\n");
       printf("\n");

       printf("  Schedule File     :  %s\n",skdname);
       /* printf("  Experiment Code   :  %s     Sampling Frequency :%s\n",skd.expcode,afreq); */
       printf("  Experiment Code   :  %s\n",skd.expcode);
       printf("  Sampling Frequency:  %s,  AD bits: %d,   # of CH: %d\n",afreq, adbit, numch);
       printf("  Stations Included :  %s",skd.statnam[0]);
       for (i=1; i<skd.nstation; i++){ printf("  %s",skd.statnam[i]); }
       printf("\n");
       printf("  My Station Name   :  %s (My Station ID : %s)\n",mystation,stat_id);
       printf("  Total Scan Number :  %d\n",skd.nobs);

       printf("  1st Scan          :  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s\n",
                      yearf,monthf,mdayf,hhf,mmf,ssf,skd.dura[0],skd.obsstar[0]);
       printf("  Last Scan         :  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s\n",
                      yearl,monthl,mdayl,hhl,mml,ssl,skd.dura[skd.nobs-1],skd.obsstar[skd.nobs-1]);

       printf("  Obs Range (start) :  %04d/%02d/%02d %02d:%02d:%02d\n",
                      year1,month1,mday1,hh1,mm1,ss1);
       printf("  Obs Range (end)   :  %04d/%02d/%02d %02d:%02d:%02d\n",
                      year2,month2,mday2,hh2,mm2,ss2);
       printf("\n");

       printf("\033[2B");  // J[\ɂQs

       if(time_mode == 1) {
           if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) return -1 ;
           ddd=day;
           year=yearPC;
           ddd2md(year, ddd, &month, &mday);
       } else {
           getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
           secnow=hh*3600+mm*60+ss;
           md2ddd(year, &ddd, month, mday);
       }
       dtimenow=ddd+secnow/86400.0;
       printf("  Time Now (UTC)    :  %04d/%02d/%02d %02d:%02d:%02d\n\033[A",
                   year,month,mday,hh,mm,ss);
       printf("\033[2A");  // J[\ɂQs


       //fixspan=10;   // compulsory fix span length (sec)
       //nobs=0;
       //flagobs=0;
       while(1)
      {                                 // observation routine

           /* next observation start time get */
           yearn=skd.start[nobs][0]+2000;
           dddn=skd.start[nobs][1];
           hhn=skd.start[nobs][2];
           mmn=skd.start[nobs][3];
           ssn=skd.start[nobs][4];
           secnext=hhn*3600+mmn*60+ssn;
           daynext=dddn;
           //printf("daynext  %d\n",daynext);
           dtimenext=daynext+secnext/86400.0;
           ddd2md(yearn,dddn,&monthn,&mdayn);
           obsspan=skd.dura[nobs];
           dtimenext2=dtimenext+(double)obsspan/86400.0;
           if(fixspan > obsspan || fixspan==0)
           {
             printf("\033[2K  Next Scan(No.%04d):  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec)  %s\n",
                      nobs+1,yearn,monthn,mdayn,hhn,mmn,ssn,obsspan,skd.obsstar[nobs]);
                       // \033[2K  means erases the entire current line
           } else
           {
             printf("\033[2K  Next Scan(No.%04d):  %04d/%02d/%02d %02d:%02d:%02d  (%3dsec ==>%3dsec)  %s\n",
                      nobs+1,yearn,monthn,mdayn,hhn,mmn,ssn,obsspan,fixspan,skd.obsstar[nobs]);
           }
           printf("\n");
           /*
           if (dtimenow > dtimenext2 ) // next observation set
           {
              nobs++;
              printf("\033[2A");  // J[\ɂQs
              goto pass2;
           }
           */

       loop1:

           /* compare system time */
           usleep(SLEEP_USEC);
           //getsystime(&year, &month, &mday, &hh, &mm, &ss, &iofset);
           if(time_mode == 1) {
              if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) return -1 ;
              ddd=day;
              year=yearPC;
              ddd2md(year, ddd, &month, &mday);
           } else {
              getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
              secnow=hh*3600+mm*60+ss;
              md2ddd(year, &ddd, month, mday);
           }
           dtimenow=ddd+secnow/86400.0;
           //printf("Total Day  %d  %f\n", ddd, dtimenow); 
           if (dtime1 > dtimenext2 ) // next observation set
           {
              nobs++;
              if(nobs > skd.nobs) { goto exitend; }   // add on 2002/7/22
              printf("\033[2A");  // J[\ɂQs
              goto pass2;
           }
      	/*
           if (dtimenow < dtime1) { goto pass1; }
           if (dtimenow < dtime1st) { goto pass1; }
           if (dtimenow > dtime2) { goto exitend; }
           if (dtimenow > dtimelast) { goto exitend; }
           if (dtimenow >= dtimenext && dtimenow < dtimenext2 ) 
      	*/
      	   /*  for autoobs2 */
           if ((dtimenow+d1sec) < dtime1) { goto pass1; }
           if ((dtimenow+d1sec) < dtime1st) { goto pass1; }
           if (dtimenow > dtime2) { goto exitend; }
           if (dtimenow > dtimelast) { goto exitend; }
           if ((dtimenow+d1sec) >= dtimenext && dtimenow < dtimenext2 ) 
           { 
              /* sampling start */

              /* out file name creation */
              /*  Xdddnnn.dat   X-- satation id  ddd -- total day,  nnn -- obs number  */
              // sprintf(fname,"%1s%03d%03d.dat\0",stat_id,dddf,nobs+1);
              sprintf(fname,"%1s%03d%04d.dat\0",stat_id,dddf,nobs+1);  // for autoobs2
              strcpy(outfile,outdir);
              strcat(outfile,fname);
              //printf("%s\n",outfile);
              /* obsspan re-calc */
              //printf("obsspan   %d\n",obsspan);
              //dwork=(dtimenext2 - dtimenow)*86400.0;  // 2002-08-15
              dwork=(dtimenext2 - dtimenow-d1sec)*86400.0;  // 2002-08-15
              //obsspan=(int)dwork ;                      // 2002-08-15
              obsspan=nint(dwork) ;                      // 2002-08-15
              //printf("obsspan(after)   %d\n",obsspan);
              if (fixspan > obsspan | fixspan==0)
              {  span=obsspan; }
              else
              {  span=fixspan; }
              printf("\033[B");  // J[\ɂPs
              printf("OUT file name ==> %s\n",outfile);
              rv=sampleget(outfile, span, sfreq, adbit, numch);
              nobs++;
              //printf("\033[A\033[A");  // J[\ɂQs
              //goto pass2;
              goto obsloop;
           
           }
           if (dtimenow > dtimenext2 ) // next observation set
           {
              nobs++;
              printf("\033[2A");  // J[\ɂQs
              goto pass2;
           }

       pass1:
           if (secnow != secold)
           {
             printf("  Time Now (UTC)    :  %04d/%02d/%02d %02d:%02d:%02d\n\033[A",
                      year,month,mday,hh,mm,ss);
           }
           secold=secnow; 
           goto loop1;
        pass2:

       }

  exitend:

       printf("\n\n");   


       return 0;
}

