/**************************************************************/
/*                                                            */
/*   ho|ukahpCN[ht@C libipvlbi.h         */
/*          Tv[{[hANZXȊO                      */
/*                                                            */
/*      Version:    2002-10-08                                */
/*                                                            */
/*      Copyright (c) 2002 T.Kondo/CRL All Right Reserved     */
/*                                                            */
/**************************************************************/
/*                                   */
/* ho|ukahpwb_[t@C  */
/*    Tv[{[hANZXȊO     */
/*         by T.Kondo 2001.8.26      */
/*                    2002.5.26      */
/*                    2002.7.06      */
/*                                   */

#ifndef _LIBIPVLBI_
#define _LIBIPVLBI_

#ifndef FILEMAXSIZE
#define FILEMAXSIZE  2000000000   //  File maximum limit size in bytes
#endif
#ifndef PIRA
#define PIRA  1.745329252E-2    // PI/180  degree to radian
#endif
#ifndef PIDE
#define PIDE  57.29577951       // 180/PI radian to degree
#endif
#ifndef TWOPI
#define TWOPI 6.283185307       // 2PI
#endif
#ifndef PI
#define PI    3.141592653
#endif

#ifndef MAXSTAR
#define MAXSTAR 1500            // Maximum star numbers in schedule file
#endif

#ifndef MAXOBS
#define MAXOBS 2000            // Maximum observation (scan) numbers is schedule file
#endif

#ifdef WIN32
typedef unsigned int    u_int32_t;
#endif


typedef struct schedule
{
     char expcode[11];     // experiment code

     char starnam1[MAXSTAR][11];   // star name1
     char starnam2[MAXSTAR][11];   // star name2
     double ra[MAXSTAR];         // star position RA  in degree
     double dec[MAXSTAR];        //       "       DEC in degree
     double epo[MAXSTAR];        //       "       Epoch
     int    nstar;          // mu,ber of stars

     char statnam[20][11];  // station name
     double xyz[20][3];     // station position (x,y,z) in m
     char statid[20][2];       // station ID (A1)
     int nstation;          // number of stations

     double freqtab[16];    // frequency table
     int nfreq;             // number of frequency

     char obsstar[MAXOBS][11];  // Obs schedule Star name
     int starid[MAXOBS];       // Star ID  (entry at starpos table)
     int start[MAXOBS][5];     // start time   YY, DDD, HH, MM, SS
     int dura[MAXOBS];         // obs duration
     char obsid[MAXOBS][21];     // station IDs participated in this obs
     int nobs;               // Number of Observations
     
} sked_data_t;


// following 2 functions uses "timeval" structure that is available only
//     on FreeBSD or linux
#ifndef WIN32

void sec2ymds(struct timeval *tv, int *year, int* month, int* mday, int* hh, int* mm, int* ss);
void getsystimef(int* year, int* month, int* mday, int* hh, int* mm, int* ss, 
                      float *fsec, float *tofset);
#endif


long int nint(double x);
void read1line(char *line);
int leaf_year_check(int year);   // 邤N̂΂@O^[
void sec2hms(long int sec, int* hh, int* mm, int* ss);
void ddd2md(int year, int ddd, int* month, int* mday);
void md2ddd(int year, int* ddd, int month, int mday);
void timecorrect(int* year, int* month, int* mday,
                int* hh, int* mm, int* ss, int* secadd);

void readskd(char* fname, sked_data_t *skd);
void parsebit32n(unsigned char* bit32, int* spatn, 
				int* smplbit, int* sfreq, int* numch,
				long int* seconds);

void headerchkn(unsigned char* bit64, int* iok, int* spatn, int* smplbit,
			   int* sfreq, int* numch, long int* seconds, int* hh,
			   int* mm, int* ss);
void parseADdata(u_int32_t *ia, int numb, int adbit, int *xdata, int *npos);

void parseADdata_2(unsigned char *ia, int numb, int adbit, int *xdata, int *npos);
void parseADdata_3(unsigned char *ia, int numb, int adbit, int *xdata, int *npos);


long int nint(double x)
{
	double t;
	long int j;
	//t=x;
	t=fabs(x)+0.5;    // abs ݂̂ł͐ɂȂĂ܂̂fabsg
	//cout << "x=" << x << " t=" << t << '\n' ; // debug
    j=(long int)t;
	if( x < 0)
	   j=-j;
	return j;
}

void read1line(char *line)
{
    //char cbuf[128];
    //char *pibuf=cbuf;
    char c;
    /* PsR[h܂œǂݍ */
    while(1)
    {
         scanf("%c",&c);
         if(c=='\n' || c=='\r') goto exitread;
         //*pibuf++ =c;
         *line++ =c;
     }
     exitread: 
     //*pibuf='\0';
     //strcpy(line,cbuf);
     *line='\0';
}

void sec2hms(long int sec, int* hh, int* mm, int* ss)
{
	long int j;
	*hh=sec/3600 ;
       j=sec-*hh*(long)3600;
       *mm=(int)(j/60) ;
	*ss=(int)(j-*mm*(long)60) ;
}


int leaf_year_check(int year)   // N̂΂@O^[
{
       /* leaf year check */
      if (year-(year/4)*4 == 0) 
      { 
          if (year-(year/100)*100 == 0) 
          { 
               if (year-(year/400)*400 == 0) { return 0;}
               return -1;
           }
           return 0;
       }
       return -1;
}

void ddd2md(int year, int ddd, int* month, int* mday)
{
      int md[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
      int i,td,wd ;
       /* leaf year check */
      if (leaf_year_check(year)==0)
      {
         md[1]=29;
      }
      *month=0;
      *mday=0;
      td=ddd;
      for (i=0; i< 12; i++)
      {
         wd=td-md[i];
         if (wd <=0)
         {
           *mday=td;
           *month=i+1;
           goto exithere;
          }
         td=wd;
       }
   exithere:;
 }

void md2ddd(int year, int* ddd, int month, int mday)
{
      int md[12] = {0,31,28,31,30,31,30,31,31,30,31,30};
      int i;
       /* leaf year check */
      if (leaf_year_check(year)==0)
      {
         md[2]=29;
      }
      *ddd=0;
      for (i=0; i< month; i++)
      {
        *ddd=*ddd+md[i];
      }
      *ddd += mday;
 }

#ifndef WIN32
 void sec2ymds(struct timeval *tv, int *year, int* month, int* mday, int* hh, int* mm, int* ss)
{
      //  tv.tv_sec  is  seconds from 1970/1/1 0h UTC
        
      int eday,edayold, secofday, secinh, yyyy, tday;
      eday = tv->tv_sec/86400  ;
      secofday=tv->tv_sec-eday*86400 ;
      *hh = secofday/3600 ;
      secinh = secofday-(*hh)*3600 ;
      *mm = secinh/60 ;
      *ss = secinh-(*mm)*60;

      yyyy=1970;
 loop1:
      edayold=eday;
      /* leaf year check */
      tday=365 ;
      if (leaf_year_check(yyyy)==0) {tday=366; }
      eday=edayold-tday;
      if (eday > 0 )
      { 
         yyyy++;
         goto loop1;
       }
       ddd2md(yyyy, edayold, &(*month), &(*mday));
       *year =yyyy;
 }
#endif

void timecorrect(int* year, int* month, int* mday,
                int* hh, int* mm, int* ss, int* secadd)
{
	//char cbuf[60];
	int seconds, tday, yyyy, allday;
       seconds=(*hh)*3600+(*mm)*60+(*ss);
       seconds += *secadd;
       yyyy=*year;
       md2ddd(yyyy, &tday, *month, *mday);
       if (seconds >= 86400)
       {
          tday=tday+1;
          seconds=seconds-86400;
       }
       else if ( seconds < 0 )
       {
          tday=tday-1;
          seconds=seconds+86400;
       }
       yyyy=*year;
       allday=365;
       if (leaf_year_check(yyyy)==0)
       {  allday=366; }
       if (tday <=0 ) 
       {
         *year -= 1;
       }
       else if ( tday > allday)
       {
         *year += 1;
         tday=tday-allday;
       }
       sec2hms(seconds, hh, mm, ss);
       yyyy=*year;
       ddd2md(*year, tday, &(*month), &(*mday));
}


#ifndef WIN32
 void getsystimef(int* year, int* month, int* mday, int* hh, int* mm, int* ss, 
                      float *fsec, float *tofset)
 {
       struct timeval tv;
       struct timezone tz;
       int iwork;
       //float fsec, tofset ;
       float fwork;
   
       //int month,mday;
       gettimeofday(&tv,&tz);    // ̊֐AQOOON[Nł͂ȂƌȂĂ悤I
       tv.tv_sec += 86400;       // Now is after 2000, so I add 1 day (86400sec)
       *fsec=tv.tv_usec/1000000.0+ (*tofset);   
       fwork=*fsec;
       iwork=(int)fwork;
       if (fwork < 0.0 )
       {
         iwork -= 1;
       }
       tv.tv_sec += iwork;
       *fsec=fwork-(float)iwork;
        //printf("FSEC = %f\n",*fsec);
      //sec2ymds(&tv, &(*year), &(*month), &(*mday), &(*hh), &(*mm), &(*ss));
       sec2ymds(&tv, year, month, mday, hh, mm, ss);
  }
#endif

void readskd(char* fname, sked_data_t *skd)
{
       //sked_data_t skd;
       char line[500];
       char cbuf[21];
	//char* spc="                    " ; // 20" "   
	char spc[]="                    " ; // 20" "   
       char starnam[11];
       char altnam[11];
       char wstatnam[20][11];  // station name work
       char wstatid[20][2];
	char s1[21];
	char s2[21];
	char s3[21];
       char s4[61];
	//char* fname="D:/IPVLBI/data/tds16a.dat"; 
       int i,k;
       int i1,i2,i3,i4,i5  ;  // work integers
       double d1,d2,d3   ;      // work doubles
       float f3;         // float work
       float pcal,vbw;    // PCAL frequency, video width
       double pi=3.14159265;  // PI
       int len;
       int idct;  // $STATION staion ID field counter (temporary use)
       FILE *stream;
       fpos_t pos;

	printf("FILE : %s\n",fname);

       if( (stream  = fopen( fname, "r" )) == NULL )
       {
          //perror( "̓t@CJ܂" );
          //exit( 1 );
	   // return -1;
          printf("File not found or Open Error! \n");
          exit(1);
	   //goto exitend2;
        }

        skd->nstar=0;
        skd->nstation=0;
        skd->nfreq=0;
        skd->nobs=0;
        idct=0;

     loop1:

       if( fgets( line, 500, stream ) == NULL)
        {
          //printf("File EOF or Read Error!\n");
	   goto exitend;
        }
        /* Schedule File Analysis */    
	if(line[0]=='*') {  goto loop1; } // this is comment line (nothing to do)  
       
	if(line[0]=='$')  // this is command line  
       {
 loop2:
          len = strlen(line);
          //printf("len = %d\n",len);  // debug
          if (len >= 5)
          { 
          //strncpy(s1,line,5);
          //strcpy(s2,"$EXPER");
	     if(strncmp(line,"$EXPER",5)==0)        // R[h   
            {      
              k=sscanf(line, "%s %s", cbuf, skd->expcode); 
              printf("$EXPER Detected! \n");
              printf("EXPCODE = %s\n",skd->expcode);
            }
	     else if(strncmp(line,"$PARAM",5)==0)        // p[^   
            { 
               /* not used in IP-VLBI */     
               //printf("$PARAM Detected! \n");
            }
	     else if(strncmp(line,"$SOURCES",5)==0)        // dg   
            {      
               printf("$SOURCES Detected! \n");
  loop_star:
               if( fgets( line, 500, stream ) == NULL)
               {
                 //printf("File EOF or Read Error!\n");
	          goto exitend;
               }
	        if(line[0]=='*') {  goto loop_star; } // this is comment line (nothing to do)  
	        if(line[0]=='$') {   goto loop2; } // this is command line  
                //printf("%s\n",line);

             //    k=sscanf(line, "%s %s %d %d %s %d %d %s %f",      // deleted on 2002-07-06
             //      starnam,altnam,&i1,&i2,s1,&i3,&i4,s2,&f3);    // 
                 k=sscanf(line, "%s %s %d %d %s %s %d %s %f",      // 2002-07-06
                   starnam,altnam,&i1,&i2,s1,s3,&i4,s2,&f3);    //   
                 d1=atof(s1);
                 d2=atof(s2);
 		  i3=atoi(s3);  //2002-07-06 
               //printf("%d %f %f\n",skd->nstar+1,d1,d2);
               strcpy(skd->starnam1[skd->nstar],starnam);
               strcpy(skd->starnam2[skd->nstar],altnam);
               d3=(double)i1*15.0+(double)i2/4.0 + d1/240.0 ;
               skd->ra[skd->nstar]=d3;
               i5=abs(i3);
               d3=(double)i5+(double)i4/60.0 + d2/3600.0 ;
               //if (i3 <0) { d3 = -d3 ; }         // deleted  on 2002-07-06
               if (strncmp(s3,"-",1) == 0) { d3 = -d3 ; }        // 2002-07-06
               skd->dec[skd->nstar]=d3;
               skd->epo[skd->nstar]=f3;
               skd->nstar++;
               if(skd->nstar >= MAXSTAR) {
                   printf("Number of Stars exceeds limit (MAXSTAR)\n");
                   skd->nstar -= 1;    // to avoid array overflow
               }
               goto loop_star;               
            }
	     else if(strncmp(line,"$STATIONS",5)==0)        // ǈʒu   
            {      
               printf("$STATIONS Detected! \n");
  loop_station:
               if( fgets( line, 500, stream ) == NULL)
               {
                 //printf("File EOF or Read Error!\n");
	          goto exitend;
               }
	        if(line[0]=='*') {  goto loop_station; } // this is comment line (nothing to do)  
	        if(line[0]=='$') {   goto loop2; } // this is command line  
                 //printf("%s\n",line);
               if(line[0]=='A')    // Station ID set
               {
                   k=sscanf(line, "%*s %s %s", s1,s2); 
                 //  printf("ID NAME length %d %d\n",strlen(s1),strlen(s2));
                   strcpy(wstatid[idct],s1);
                   strcpy(wstatnam[idct],s2);
                   idct++;
                }
               if(line[0]=='P')    // Station XYZ
               {
                   k=sscanf(line, "%*s %*s %s %s %s %s", cbuf,s1,s2,s3); 
                   d1=atof(s1);
                   d2=atof(s2);
                   d3=atof(s3);
                   strcpy(skd->statnam[skd->nstation],cbuf);
                   skd->xyz[skd->nstation][0]=d1;
                   skd->xyz[skd->nstation][1]=d2;
                   skd->xyz[skd->nstation][2]=d3;
                   skd->nstation++;
                }
                goto loop_station;               
            }
	     else if(strncmp(line,"$CODES",5)==0)        // g   
            {      
               printf("$CODES Detected! \n");
  loop_freq:
               if( fgets( line, 500, stream ) == NULL)
               {
                 //printf("File EOF or Read Error!\n");
	          goto exitend;
               }
	        if(line[0]=='*') {  goto loop_freq; } // this is comment line (nothing to do)  
	        if(line[0]=='$') {   goto loop2; } // this is command line  
                 //printf("%s\n",line);
               if(line[0]=='C')    // Frequency info
               {
                   k=sscanf(line, "%*s %*s %*s %s %f %d %*s %f", s1,&pcal,&i1,&vbw); 
                   //printf("%d %s %f %d %f %d\n",skd->nfreq,s1,pcal,i1,vbw,strlen(s1));
              
                   //strcat(s1,"\0");
                   if(*s1 != 'x' && *s1 != 'X') {    // to avoid  xxxx.xx or XXXX.XX
                      d1=atof(s1);
                      //d1=atof("1234.567");  debug
                      //printf("d1= %f\n",d1);
                      //printf("d1= %f\n",atof("1234.567"));
                      skd->freqtab[i1-1]=d1;
                      skd->nfreq++;
                   }
                }
                goto loop_freq;               
            }
	     else if(strncmp(line,"$SKED",5)==0)        // XPW[   
            {      
               printf("$SKED Detected! \n");
  loop_sked:
               if( fgets( line, 500, stream ) == NULL)
               {
                 //printf("File EOF or Read Error!\n");
	          goto exitend;
               }
	        if(line[0]=='*') {  goto loop_sked; } // this is comment line (nothing to do)  
	        if(line[0]=='$') {   goto loop2; } // this is command line  
                 //printf("%s\n",line);
               k=sscanf(line, "%s %*s %*s %*s %s %d %*s %*d %*s %s", s1,s2,&i1,s4); 
               skd->dura[skd->nobs]=i1;
               strcpy(skd->obsstar[skd->nobs],s1);
               strncpy(cbuf,spc,20); // set all space code
               strncpy(cbuf,s2,2);
               i1=atoi(cbuf);
               strncpy(cbuf,spc,20); // set all space code
               strncpy(cbuf,s2+2,3);
               i2=atoi(cbuf);
               strncpy(cbuf,spc,20); // set all space code
               strncpy(cbuf,s2+5,2);
               i3=atoi(cbuf);
               strncpy(cbuf,spc,20); // set all space code
               strncpy(cbuf,s2+7,2);
               i4=atoi(cbuf);
               strncpy(cbuf,spc,20); // set all space code
               strncpy(cbuf,s2+9,2);
               i5=atoi(cbuf);
               skd->start[skd->nobs][0]=i1;
               skd->start[skd->nobs][1]=i2;
               skd->start[skd->nobs][2]=i3;
               skd->start[skd->nobs][3]=i4;
               skd->start[skd->nobs][4]=i5;
               len=strlen(s4);
               //printf("%d %s\n",len,s4);  // debug
               //printf("%d %d %d %d %d\n",skd->start[skd->nobs][0],
               //    skd->start[skd->nobs][1],
               //    skd->start[skd->nobs][2],
               //    skd->start[skd->nobs][3],
               //    skd->start[skd->nobs][4]);  // debug
               //strncpy(skd->obsid[skd->nobs],s4,len); // not good under WIN32 condition
               strcpy(skd->obsid[skd->nobs],s4);  //2002-09-13
               //printf("%s\n",skd->obsid[skd->nobs]);
               skd->nobs++;
               if(skd->nobs >= MAXOBS) {  
                   printf("Number of scans exceeds limit (MAXOBS)\n");
                   skd->nobs -= 1;    // to avoid array overflow
               }
               goto loop_sked;               
            }
            /*
	     else if(strncmp(line,"$HEAD",5)==0)        // head stack information  
            {      
               printf("$HEAD Detected! \n");
            }
	     else if(strncmp(line,"$FLUX",5)==0)        // FLUX    
            {
               printf("$FLUX Detected! \n");
            }
	     else if(strncmp(line,"$PROC",5)==0)        // station procedure    
            {
               printf("$PROC Detected! \n");
            }
            */
            else
            {
              /*
              printf("Unknown $ parameter detected as follows\n");
              printf("%s\n",line);
              */
            }
         } else 
         { 
           /*
            if (len >=3 && strncmp(line,"$OP",3)==0)        // $OP   
               {      
                  printf("$OP Detected! \n");
               }
            else
            {
              printf("Unknown $ parameter detected as follows\n");
              printf("%s\n",line);
            }
           */
         }
       }
       goto loop1;
 exitend:
       fgetpos(stream,&pos);  //debug
	i=fclose( stream ) ;
       //printf("%d bytes read\n",pos); 

       printf("Number of Sources = %d\n",skd->nstar);
/*
       for (i=0; i < skd->nstar; i++)
       {
          //strcpy(starnam,skd->starnam[i]);
          printf("%d %s %s %f %f %f\n",i+1,skd->starnam1[i],skd->starnam2[i],
             skd->ra[i],skd->dec[i],skd->epo[i]);
          //printf("%d %s\n",i+1,starnam);
       }
*/     
       printf("Number of Stations = %d\n",skd->nstation);
       /* Station ID table set up */
       
       for (i=0; i < skd->nstation; i++)
       {
          strncpy(cbuf,spc,20); // set all space code
          strcpy(cbuf,skd->statnam[i]);
          for (k=0; k < idct; k++)
          { 
              strncpy(s1,spc,20); // set all space code
              strcpy(s1,wstatnam[k]);
              len=strlen(s1);
              //printf("len = %d\n",len);
              if (strncmp(cbuf,s1,len)==0)
              {  
                      //strncpy(skd->statid[i],' ',1);
                      strcpy(skd->statid[i],wstatid[k]);
                      goto exithere1; }
           }
           exithere1:
           ;
        }
/*       
       for (i=0; i < skd->nstation; i++)
       {
          printf("%d %s %s %f %f %f\n",i+1,skd->statid[i],skd->statnam[i],
               skd->xyz[i][0],skd->xyz[i][1],skd->xyz[i][2]);
       }
*/      
       printf("Number of Frequencies = %d\n",skd->nfreq);
/*
       for (i=0; i < skd->nfreq; i++)
       {
          printf("%d %f\n",i+1,skd->freqtab[i]);
       }
       
*/
       /* Obs Star Index Table Setup */
       if (skd->nstar > 0) 
       {
           for (i=0; i < skd->nobs; i++)
           {
               strncpy(cbuf,spc,20); // set all space code
               strcpy(cbuf,skd->obsstar[i]);
               for (k=0; k < skd->nstar; k++)
               {
                   strcpy(s1,skd->starnam1[k]);
                   len=strlen(s1);
                   //printf("len = %d\n",len);
                   if (strncmp(cbuf,s1,len)==0)
                   {  skd->starid[i]=k;
                      goto exithere; }
                   strcpy(s1,skd->starnam2[k]);
                   len=strlen(s1);
                   if (strncmp(cbuf,s1,len)==0)
                   {  skd->starid[i]=k;
                      goto exithere; }
                 }
                 skd->starid[i]=-1;
   exithere:
   ;
             }
         }
         

       printf("Number of Observations = %d\n",skd->nobs);
/*       
       for (i=0; i < 10; i++)
       {
          printf("%d %s %d %d %d %d %d %d   %d %s\n",i+1,skd->obsstar[i],skd->starid[i],
                 skd->start[i][0],skd->start[i][1],skd->start[i][2],
                 skd->start[i][3],skd->start[i][4],skd->dura[i],skd->obsid[i]);
       }
       for (i=skd->nobs-10; i < skd->nobs; i++)
       {
          printf("%d %s %d %d %d %d %d %d   %d %s\n",i+1,skd->obsstar[i],skd->starid[i],
                 skd->start[i][0],skd->start[i][1],skd->start[i][2],
                 skd->start[i][3],skd->start[i][4],skd->dura[i],skd->obsid[i]);
       }
 */      
 //exitend2:

}

void parsebit32n(unsigned char* bit32, int* spatn, 
				int* smplbit, int* sfreq, int* numch,
				long int* seconds)
{
    int sdat[16]={1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0};
    int fdat[16]={40,100,200,500,1000,2000,4000,8000,16000, 
                 0,0,0,0,0,0,0};
    int smplbit0, sfreq0, seco, nch;
    *spatn=(int)(bit32[3] & 255);       // spatn = 139 means sync pattern
    smplbit0 = (bit32[2] >> 6) & 15;    // 6 times bit shift to right
    *smplbit = sdat[smplbit0];
    sfreq0 = ( bit32[2] >> 2) & 15 ;
    *sfreq=fdat[sfreq0];
    nch = bit32[2] & 2;
    if (nch == 2) {
       *numch = 4; 
    } else {
       *numch = 1;
    }
    seco = bit32[2] & 1;
    *seconds=seco*(long int)65536+
		(long int)(bit32[1] & 255)*(long int)256+
		(long int)(bit32[0] & 255);
}

/* headerchkn is updated on 2002-9-28 */
/* old version is rename to headerchkn_old */

void headerchkn(unsigned char* bit64, int* iok, int* spatn, int* smplbit,
			   int* sfreq, int* numch, long int* seconds, int* hh,
			   int* mm, int* ss)
{
    int sdat[16]={1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0};
    int fdat[16]={40,100,200,500,1000,2000,4000,8000,16000, 
                 0,0,0,0,0,0,0};
    int smplbit0, sfreq0, seco, nch;
    *iok=-1;
    /* sync pattern check */
    if((bit64[0] == 0xFF) && (bit64[1] == 0xFF) && 
        (bit64[2] == 0xFF) && (bit64[3] == 0xFF) && (bit64[7] == 0x8B)){  // this is sync block (new FMT)

        *iok=0;
        /* parse sampling information and get time data */ 
        *spatn=(int)(bit64[7] & 255);       // spatn = 139 means sync pattern
        smplbit0 = (bit64[6] >> 6) & 15;    // 6 times bit shift to right
        *smplbit = sdat[smplbit0];
        sfreq0 = ( bit64[6] >> 2) & 15 ;
        *sfreq=fdat[sfreq0];
        nch = bit64[6] & 2;
        if (nch == 2) {
            *numch = 4; 
        } else {
            *numch = 1;
        }
        seco = bit64[6] & 1;
        *seconds=seco*(long int)65536+
		        (long int)(bit64[5] & 255)*(long int)256+
		        (long int)(bit64[4] & 255);
        sec2hms(*seconds,&(*hh),&(*mm),&(*ss));
    }
}

void headerchkn_old(unsigned char* bit64, int* iok, int* spatn, int* smplbit,
			   int* sfreq, int* numch, long int* seconds, int* hh,
			   int* mm, int* ss)
{
    unsigned char bit32a[4];
    unsigned char bit32b[4];
    int i;
    *iok=-1;
    for (i=0; i<4; i++){
       bit32a[i]=bit64[i];
       bit32b[i]=bit64[i+4];
    }
    if((bit32a[0] == 0xFF) && (bit32a[1] == 0xFF) && 
       (bit32a[2] == 0xFF) && (bit32a[3] == 0xFF) )   // this is sync block (new FMT)
    {
        /* sync patern check in next 2nd 32bit data */ 
        parsebit32n(bit32b,&(*spatn),&(*smplbit),&(*sfreq),&(*numch),&(*seconds));
        if (*spatn == 139)  //  this is also sync
	 {
           *iok=0;
           //sec2hms(&(*seconds),&(*hh),&(*mm),&(*ss));
           sec2hms(*seconds,&(*hh),&(*mm),&(*ss));
       }
     }
}



void parseADdata(u_int32_t *ia, int numb, int adbit, int *xdata, int *npos)
{
/*
    IP-VLBI{[hf[^A/D\ɉTvOlɕϊ
      ch͂̎_ł͊֌WȂ

      [in]
         ia  ---  sampler (IP-VLBI board) out data 
         numb --  size of ia (bytes)
         adbit -- sampler A/D resolution bits (1,2,4,8)
      [return]
         xdata -- data parsed into each sampled data
         npos  -- valid number of data in xdata array

     Relation between # of ch (numch) and each ch time siries

        chnumchƂ
        ch# mk Ԗڂ̃Tvf[^

        sdata(m,k)=xdata(k*numch+m)

        ƂȂ
        
*/
     int numb32, pat, n, i, ilast, ipos, ww;
     u_int32_t wd1,wd2;
     numb32=numb/4;
     ipos=0;
     ilast=32/adbit;
     pat=255;
     if (adbit == 1) {pat=1;}
     if (adbit == 2) {pat=3;}
     if (adbit == 4) {pat=15;}
     // if (adbit == 8) {pat=255;} 

     for( n=0; n < numb32-1; n++)
     {
        wd1=ia[n];
        wd2=ia[n+1];
        /* check sync pattern */
        //if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0xFF000000UL) )  // sync detected
        if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0x8B000000UL) )  // sync detected 02-07-17
         {      //printf("Sync detected ");   // removed  on 2002-10-3 
                goto exit1;
         }
        for(i=0; i<ilast; i++)
        {
             ww=(int)(wd1 & pat);
             xdata[ipos]=ww;
             wd1=wd1 >> adbit ; 
             ipos++;
         }
       exit1:  ;
     }
     *npos=ipos;
}


void parseADdata_2(unsigned char *ia, int numb, int adbit, int *xdata, int *npos)
{
/*
    IP-VLBI{[hf[^A/D\ɉTvOlɕϊ
      ch͂̎_ł͊֌WȂ

      [in]
         ia  ---  sampler (IP-VLBI board) out data 
         numb --  size of ia (bytes)
         adbit -- sampler A/D resolution bits (1,2,4,8)
      [return]
         xdata -- data parsed into each sampled data
         npos  -- valid number of data in xdata array

     Relation between # of ch (numch) and each ch time siries

        chnumchƂ
        ch# mk Ԗڂ̃Tvf[^

        sdata(m,k)=xdata(k*numch+m)

        ƂȂ
        
*/
     int numb8, pat, n, i, ilast, ipos, ww;
     u_int32_t wd1,wd2;
     numb8=numb;
     ipos=0;
     ilast=32/adbit;
     pat=255;
     if (adbit == 1) {pat=1;}
     if (adbit == 2) {pat=3;}
     if (adbit == 4) {pat=15;}
     /* if (adbit == 8) {pat=255;} */


     wd1=((u_int32_t)ia[3] << 24);
     wd1=(wd1 | (u_int32_t)ia[2] << 16);
     wd1=(wd1 | (u_int32_t)ia[1] <<  8);
     wd1=(wd1 | (u_int32_t)ia[0]);

     //printf("IN PARSE ia %d %d %d %d\n",(u_int32_t)ia[0],(u_int32_t)ia[1],(u_int32_t)ia[2],(u_int32_t)ia[3]);

     for( n=4; n < numb8-3; n+=4)
     {
        wd2=((u_int32_t)ia[n+3] << 24);
        wd2=(wd2 | (u_int32_t)ia[n+2] << 16);
        wd2=(wd2 | (u_int32_t)ia[n+1] <<  8);
        wd2=(wd2 | (u_int32_t)ia[n]);

        /* check sync pattern */
        //if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0xFF000000UL) )  // sync detected
        if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0x8B000000UL) )  // sync detected 02-07-17
         {      printf("Sync detected \n"); 
                goto exit1;
         }
        for(i=0; i<ilast; i++)
        {
             ww=(int)(wd1 & pat);
             //printf("ww wd1 pat %d %d %d",ww,wd1,pat); //debug
             xdata[ipos]=ww;
             wd1=wd1 >> adbit ; 
             ipos++;
         }
         wd1=wd2;
       exit1:  ;
     }
     for(i=0; i<ilast; i++)
     {
         ww=(int)(wd1 & pat);
         //printf("ww wd1 pat %d %d %d",ww,wd1,pat); //debug
         xdata[ipos]=ww;
         wd1=wd1 >> adbit ; 
         ipos++;
     }
     *npos=ipos;
}

void parseADdata_3(unsigned char *ia, int numb, int adbit, int *xdata, int *npos)
{
/*
    IP-VLBI{[hf[^A/D\ɉTvOlɕϊ
      ch͂̎_ł͊֌WȂ

      [in]
         ia  ---  sampler (IP-VLBI board) out data 
         numb --  size of ia (bytes)
         adbit -- sampler A/D resolution bits (1,2,4,8)
      [return]
         xdata -- data parsed into each sampled data
         npos  -- valid number of data in xdata array

     Relation between # of ch (numch) and each ch time siries

        chnumchƂ
        ch# mk Ԗڂ̃Tvf[^

        sdata(m,k)=xdata(k*numch+m)

        ƂȂ
        
*/
     int numb8, pat, n, i, ilast, ipos, ww;
     u_int32_t wd1,wd2;
     numb8=numb;
     ipos=0;
     ilast=32/adbit;
     pat=255;
     if (adbit == 1) {pat=1;}
     if (adbit == 2) {pat=3;}
     if (adbit == 4) {pat=15;}
     /* if (adbit == 8) {pat=255;} */


     wd1=((u_int32_t)ia[3] << 24);
     wd1=(wd1 | (u_int32_t)ia[2] << 16);
     wd1=(wd1 | (u_int32_t)ia[1] <<  8);
     wd1=(wd1 | (u_int32_t)ia[0]);

     //printf("IN PARSE ia %d %d %d %d\n",(u_int32_t)ia[0],(u_int32_t)ia[1],(u_int32_t)ia[2],(u_int32_t)ia[3]);

     for( n=4; n < numb8-3; n+=4)
     {
        wd2=((u_int32_t)ia[n+3] << 24);
        wd2=(wd2 | (u_int32_t)ia[n+2] << 16);
        wd2=(wd2 | (u_int32_t)ia[n+1] <<  8);
        wd2=(wd2 | (u_int32_t)ia[n]);

        /* check sync pattern */
        //if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0xFF000000UL) )  // sync detected
        if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0x8B000000UL) )  // sync detected 02-07-17
         {      printf("Sync detected \n"); 
                goto exit1;
         }
        for(i=0; i<ilast; i++)
        {
             ww=(int)(wd1 & pat);
             //printf("ww wd1 pat %d %d %d",ww,wd1,pat); //debug
             xdata[ipos]=ww;
             wd1=wd1 >> adbit ; 
             ipos++;
         }
         wd1=wd2;
       exit1:  ;
     }
     for(i=0; i<ilast; i++)
     {
         ww=(int)(wd1 & pat);
         //printf("ww wd1 pat %d %d %d",ww,wd1,pat); //debug
         xdata[ipos]=ww;
         wd1=wd1 >> adbit ; 
         ipos++;
     }
     *npos=ipos;
     //printf("numb8,ipos %d %d\n",numb8,ipos);
}


#endif
