/**************************************************************/
/*                                                            */
/*   ho|ukahpCN[h     libipvlbi_board.h       */
/*          Tv[{[h֌W                              */
/*                                                            */
/*      Version:    2002-10-08                                */
/*      Version:    2002-10-21                                */
/*                                                            */
/*      Copyright (c) 2002 T.Kondo/CRL All Right Reserved     */
/*                                                            */
/**************************************************************/
/*                                   */
/* ho|ukahpwb_[t@C  */
/*    Tv[{[h ֌W          */
/*         by T.Kondo 2001.8.26      */
/*                    2002.5.26      */
/*                    2002.10.21 sampleget2Gbytesȏ̊ϑ悤ɉC      */
/*                                   */
#ifndef _LIBIPVLBI_BOARD_
#define _LIBIPVLBI_BOARD_




#ifndef FILEMAXSIZE
#define FILEMAXSIZE  2000000000   //  File maximum limit size in bytes
#endif

int ini_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec);
int start_sampler(int *fd_in);
int stop_sampler(int *fd_in);
int ini_and_start_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec);
int sampleget(char* outfile, int span, int sfreq, int adbit, int numch);
int sampleget2(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode);
int ip_board_time(unsigned int *day, unsigned int *sec, int *hh, int *mm, int *ss);

/* Tv[{[h */
int ini_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec)
{
	char dev[] = "/dev/tds0";
	//int fd_in;
	int rv;
	int headbit=64;  // header bit number  for a new sampler board
	//int headbit=32;  // header bit number  for a old sampler board
	long int allbyte;     // TvOoCg
	//long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
	long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
	unsigned int sampling1, freq, width;
	int ch;
	u_int8_t sfreq_t, sbit_t, numch_t, sampling;
	//u_int32_t buf[BUFSIZ * 2];
	//printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI

/*
	printf(" span = %d\n",span);    // debug
       printf(" sfreq= %d\n",sfreq);   // debug
       printf(" adbit= %d\n",adbit);   // debug
       printf(" numch= %d\n",numch);   // debug
*/


	/* sampler open */
	*fd_in = open(dev, O_RDONLY);
	if (*fd_in == -1) {
		perror("ini_sampler : device open() error ");
		return -1;
	}

	/* sampling frequency set */

	if      (sfreq ==  40)  { sfreq_t =  TDS_SAMPLING_40KHZ; }
	else if (sfreq == 100)  { sfreq_t =  TDS_SAMPLING_100KHZ; }
	else if (sfreq == 200)  { sfreq_t =  TDS_SAMPLING_200KHZ; }
	else if (sfreq == 500)  { sfreq_t =  TDS_SAMPLING_500KHZ; }
	else if (sfreq ==   1)  { sfreq_t =  TDS_SAMPLING_1MHZ; }
	else if (sfreq ==   2)  { sfreq_t =  TDS_SAMPLING_2MHZ; }
	else if (sfreq ==   4)  { sfreq_t =  TDS_SAMPLING_4MHZ; }
	else if (sfreq ==   8)  { sfreq_t =  TDS_SAMPLING_8MHZ; }
	else if (sfreq ==  16)  { sfreq_t =  TDS_SAMPLING_16MHZ; }
	else { 
	   printf(" ini_sampler : parameter sfreq  (sampling frequency) must be either one of followings:\n");
	   printf("                40,100,200,500 (for kHz)\n");
	   printf("                1,2,4,8,16 (for MHz)\n");
          return -1;
	}
      
	/* AD resolution set */
	if      (adbit ==  1)  { sbit_t =  TDS_SAMPLING_1BIT; }
	else if (adbit ==  2)  { sbit_t =  TDS_SAMPLING_2BIT; }
	else if (adbit ==  4)  { sbit_t =  TDS_SAMPLING_4BIT; }
	else if (adbit ==  8)  { sbit_t =  TDS_SAMPLING_8BIT; }
	else { 
	   printf(" parameter adbit (A/D resolution) must be either one of followings:\n");
	   printf("              1,2,4,8\n");
          return -1;
	}

	/* number of channels set */
	if      (numch ==  1)  { numch_t =  TDS_SAMPLING_1CH; }
	else if (numch ==  4)  { numch_t =  TDS_SAMPLING_4CH; }
	else { 
	   printf(" parameter numch (number of channels) must be either one of followings:\n");
	   printf("              1,4\n");
          return -1;
	}

	/* sampling parameters set */
	sampling =  sfreq_t | sbit_t | numch_t;
	

	if (sfreq >= 40) { *bitsec=sfreq*1000 ;}
	else { *bitsec=sfreq*1000*1000 ;}

	*bitsec=(*bitsec*adbit*numch)+headbit;   // bit number per second

    bytesec=*bitsec/8;

	rv = ioctl(*fd_in, TDSIO_SET_SAMPLING, &sampling);
	if (rv == -1) {
	   perror("ini_sampler : ioctl() sampling set failed ");
	   goto end;
	}
	else {
	   printf("ini_sampler : ioctl() sampling set succeed\n");
	}


    /* get sampling parameters from a board */

	rv = ioctl(*fd_in,TDSIO_GET_SAMPLING,&sampling1);
	if (rv == -1) {
		perror("ini_sampler : ioctl() get sampling parameter failed ");
		goto end;
	}
	else {
		printf("ini_sampler : ioctl() get sampling parameter succeed\n");
		freq = TDS_GET_SAMP_FREQ(sampling1);
		width = TDS_GET_SAMP_WIDTH(sampling1);
		ch = TDS_GET_SAMP_CH(sampling1);
		if(freq == TDS_SAMPLING_40KHZ)
			freq = 40;
		if(freq == TDS_SAMPLING_100KHZ)
			freq = 100;
		if(freq == TDS_SAMPLING_200KHZ)
			freq = 200;
		if(freq == TDS_SAMPLING_500KHZ)
			freq = 500;
		if(freq == TDS_SAMPLING_1MHZ)
			freq = 1000;
		if(freq == TDS_SAMPLING_2MHZ)
			freq = 2000;
		if(freq == TDS_SAMPLING_4MHZ)
			freq = 4000;
		if(freq == TDS_SAMPLING_8MHZ)
			freq = 8000;
		if(freq == TDS_SAMPLING_16MHZ)
			freq = 16000;
		if(width == TDS_SAMPLING_1BIT)
			width = 1;
		if(width == TDS_SAMPLING_2BIT)
			width = 2;
		if(width == TDS_SAMPLING_4BIT)
			width = 4;
		if(width == TDS_SAMPLING_8BIT)
			width = 8;
		if(ch == TDS_SAMPLING_4CH)
			ch = 4;
		else
			ch =1;
		printf("ini_sampler : sampling setting is %d kHz %d BIT %d CH\n",freq,width,ch);
	}	

end:
	return rv;
}


/* TvOX^[g */
int start_sampler(int *fd_in)
{
	int rv;
       
	rv = ioctl(*fd_in, TDSIO_BUFFER_CLEAR);   // {[hFIFÕNA[
	if (rv == -1) {
		perror("start_sampler : ioctl() FIFO clear failed ");
		goto end;
	}
	else {
		printf("start_sampler : ioctl() FIFO clear succeed\n");
	}

    /* sampling start */

	rv = ioctl(*fd_in, TDSIO_SAMPLING_START);
	if (rv == -1) {
		perror("start_sampler : ioctl() start sampling failed ");
		printf("                Probably time was not set for the IP-VLBI board.\n");
		printf("                Please set time using timesettk and try again.\n");
		goto end;
	}
	else {
		printf("start_sampler : ioctl() start sampling succeed\n");
	}
end:
	return rv;
}


/* TvOXgbv */
int stop_sampler(int *fd_in)
{
	int rv;

	rv = ioctl(*fd_in, TDSIO_SAMPLING_STOP);
	if (rv == -1) {
		perror("stop_sampler : ioctl() stop sampling failed ");
	} else {
		printf("stop_sampler : ioctl() stop sampling succeed\n");
	}

	close(*fd_in);
       
	return rv;
}


/* Tv[{[hуf[^WgK[ */
int ini_and_start_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec)
{
	char dev[] = "/dev/tds0";
	//int fd_in;
	int rv;
	//long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj

/*
	printf(" span = %d\n",span);    // debug
       printf(" sfreq= %d\n",sfreq);   // debug
       printf(" adbit= %d\n",adbit);   // debug
       printf(" numch= %d\n",numch);   // debug
*/

    rv=ini_sampler(&(*fd_in),sfreq, adbit, numch, &(*bitsec));
	if (rv < 0) {
		printf("ini_and_start_sampler : sampler initialize error \n");
		return rv;
	}

	rv=start_sampler(&(*fd_in));

	if (rv < 0) {
		printf("ini_and_start_sampler : start sampling failed ");
	}
	
	return rv;
}


/*  f[^W֐
   NۂɃf[^W܂łRbII
    outfile ---- f[^o̓t@C
    span    ---- f[^Wԁ@ibj
    sfreq   ---- TvOg
                    40,100,200,500 (for kHz)
                    1,2,4,8,16 (for MHz)
    adbit   ---- `crbg
                    1,2,4,8
    numch   ---- `l
                    1, 4
    2002-10-21 2Gbytesȏ̊ϑ悤ɕύX
*/
int sampleget(char* outfile, int span, int sfreq, int adbit, int numch)
{
	char dev[] = "/dev/tds0";
	int fd_in;
	int fd_out;
	mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
	int rv;
	unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
       int i,h,m,s;
       int secforce;
       int headbit=64;  // header bit number  for a new sampler board
       //int headbit=32;  // header bit number  for a old sampler board
       long int allbyte;     // TvOoCg
       long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
       long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
       long int c;
       unsigned int sampling1, freq, width;
       int ch;
	   // 2002-10-21
	   double dallbyte, dc;
	   int f_c;   // file number counter  in case of file exceeds > 2Gbyte
	   char cbuf[10];
	   char outname2[80]; // for extra output
	   // ----------
       u_int8_t sfreq_t, sbit_t, numch_t;
	u_int8_t sampling;
	u_int32_t buf[BUFSIZ * 2];
		//printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI

   /*
	printf(" span = %d\n",span);    // debug
       printf(" sfreq= %d\n",sfreq);   // debug
       printf(" adbit= %d\n",adbit);   // debug
       printf(" numch= %d\n",numch);   // debug
   */

       /* sampling duration check */
       if (span <= 0) {
          printf(" parameter span (duration in sec) should be positive!\n");
          // nothing to do
          return -1;
       }


       /* sampler open */
	fd_in = open(dev, O_RDONLY);
	//fd_in = open("/dev/tds0", O_RDONLY);
	if (fd_in == -1) {
		perror("device open() error ");
		return -1;
	}

       /* output file open */
	fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
	if (fd_out == -1) {
		perror("output file open() error");
		goto end;
	}

       /* sampling frequency set */

       if      (sfreq ==  40)  { sfreq_t =  TDS_SAMPLING_40KHZ; }
       else if (sfreq == 100)  { sfreq_t =  TDS_SAMPLING_100KHZ; }
       else if (sfreq == 200)  { sfreq_t =  TDS_SAMPLING_200KHZ; }
       else if (sfreq == 500)  { sfreq_t =  TDS_SAMPLING_500KHZ; }
       else if (sfreq ==   1)  { sfreq_t =  TDS_SAMPLING_1MHZ; }
       else if (sfreq ==   2)  { sfreq_t =  TDS_SAMPLING_2MHZ; }
       else if (sfreq ==   4)  { sfreq_t =  TDS_SAMPLING_4MHZ; }
       else if (sfreq ==   8)  { sfreq_t =  TDS_SAMPLING_8MHZ; }
       else if (sfreq ==  16)  { sfreq_t =  TDS_SAMPLING_16MHZ; }
       else { 
	   printf(" parameter sfreq  (sampling frequency) must be either one of followings:\n");
	   printf("              40,100,200,500 (for kHz)\n");
	   printf("              1,2,4,8,16 (for MHz)\n");
          return -1;
       }
      
       /* AD resolution set */
       if      (adbit ==  1)  { sbit_t =  TDS_SAMPLING_1BIT; }
       else if (adbit ==  2)  { sbit_t =  TDS_SAMPLING_2BIT; }
       else if (adbit ==  4)  { sbit_t =  TDS_SAMPLING_4BIT; }
       else if (adbit ==  8)  { sbit_t =  TDS_SAMPLING_8BIT; }
       else { 
	   printf(" parameter adbit (A/D resolution) must be either one of followings:\n");
	   printf("              1,2,4,8\n");
          return -1;
       }

       /* number of channels */
       if      (numch ==  1)  { numch_t =  TDS_SAMPLING_1CH; }
       else if (numch ==  4)  { numch_t =  TDS_SAMPLING_4CH; }
       else { 
	   printf(" parameter numch (number of channels) must be either one of followings:\n");
	   printf("              1,4\n");
          return -1;
       }

       /* sampling parameters set */
       sampling =  sfreq_t | sbit_t | numch_t;

       //if (sfreq >= 40) { bitsec=sfreq*1000 + headbit ;}   
       //else { bitsec=sfreq*1000*1000 + headbit ;}
       if (sfreq >= 40) { bitsec=sfreq*1000 ;}          //2002-9-15
       else { bitsec=sfreq*1000*1000 ;}                 //2002-9-15

       //bitsec=bitsec*adbit*numch;   // bit number per second
		bitsec=(bitsec*adbit*numch)+headbit;   // bit number per second  !! 2002-9-15

       bytesec=bitsec/8;
       allbyte=bytesec*span;
	   dallbyte=(double)bytesec*(double)span;   // 2002-10-21

       /* File maximum bytes check */
       //if (allbyte > FILEMAXSIZE){
 //      if (dallbyte > (double)FILEMAXSIZE){  // 2002-10-21
 //         allbyte= FILEMAXSIZE;
 //         secforce=allbyte/bytesec;
 //         printf(" # of bytes force to set to %d Bytes because it exceeds %d Bytes\n",
//              allbyte,FILEMAXSIZE);  // debug
//          printf(" Obserbasation span (sec) reduced to %d\n",secforce);  // debug
//        }
       printf(" bitsec  = %d\n",bitsec);  // debug
       printf(" bytesec = %d\n",bytesec);  // debug
       //printf(" allbyte = %d\n",allbyte);  // debug
       printf(" allbyte = %g\n",dallbyte);  // debug

	//sampling = TDS_SAMPLING_4MHZ | TDS_SAMPLING_1BIT | TDS_SAMPLING_1CH;

	rv = ioctl(fd_in, TDSIO_SET_SAMPLING, &sampling);
	if (rv == -1) {
	   perror("ioctl() sampling set failed ");
	   goto end;
	}
	else {
	   printf("ioctl() sampling set succeed\n");
	}


       /* get sampling parameters from a board */

	rv = ioctl(fd_in,TDSIO_GET_SAMPLING,&sampling1);
	if (rv == -1) {
		perror("ioctl() get sampling parameter failed ");
		goto end;
	}
	else {
		printf("ioctl() get sampling parameter succeed\n");
		freq = TDS_GET_SAMP_FREQ(sampling1);
		width = TDS_GET_SAMP_WIDTH(sampling1);
		ch = TDS_GET_SAMP_CH(sampling1);
		if(freq == TDS_SAMPLING_40KHZ)
			freq = 40;
		if(freq == TDS_SAMPLING_100KHZ)
			freq = 100;
		if(freq == TDS_SAMPLING_200KHZ)
			freq = 200;
		if(freq == TDS_SAMPLING_500KHZ)
			freq = 500;
		if(freq == TDS_SAMPLING_1MHZ)
			freq = 1000;
		if(freq == TDS_SAMPLING_2MHZ)
			freq = 2000;
		if(freq == TDS_SAMPLING_4MHZ)
			freq = 4000;
		if(freq == TDS_SAMPLING_8MHZ)
			freq = 8000;
		if(freq == TDS_SAMPLING_16MHZ)
			freq = 16000;
		if(width == TDS_SAMPLING_1BIT)
			width = 1;
		if(width == TDS_SAMPLING_2BIT)
			width = 2;
		if(width == TDS_SAMPLING_4BIT)
			width = 4;
		if(width == TDS_SAMPLING_8BIT)
			width = 8;
		if(ch == TDS_SAMPLING_4CH)
			ch = 4;
		else
			ch =1;
		printf("sampling setting is %d kHz %d BIT %d CH\n",freq,width,ch);
	}	



       /* board time get */
 /*
	rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
	if (rv == -1) {
		perror("ioctl() time get failed ");
		return -1;
	}
       day=TDS_GET_DAYS(time);
       sec=TDS_GET_SEC(time);
       sec2hms(sec,&h,&m,&s);
	//printf("get count day from device [%5d]\n",TDS_GET_DAYS(time));
	//printf("get count sec from device [%5d]\n",TDS_GET_SEC(time));
 	printf("%03d %02d:%02d:%02d\n",day,h,m,s);
 */

       
	rv = ioctl(fd_in, TDSIO_BUFFER_CLEAR);   // {[hFIFÕNA[
	if (rv == -1) {
		perror("ioctl() FIFO clear failed ");
		goto end;
	}
	else {
		printf("ioctl() FIFO clear succeed\n");
	}
/*       
	rv = ioctl(fd_in, TDSIO_SYNC_1PPS);           // Poorւ̓BV{[h(2002.3ȍ~)ł
	if (rv == -1) {                               // ȂĂ̍ŏɂPΗǂ
		perror("ioctl() 1pps sync failed ");   //  (Ȃǂj
		goto end;
	}
	else {
		printf("ioctl() 1pps sync succeed\n");
	}
*/
/*	rv = ioctl(fd_in, TDSIO_SYNC_TIME);            // O͎͂gpȂ
	if (rv == -1) {
		perror("ioctl() time sync failed ");
		goto end;
	}
	else {
		printf("ioctl() time sync succeed\n");
	}
*/

       /* sampling start */

	rv = ioctl(fd_in, TDSIO_SAMPLING_START);
	if (rv == -1) {
		perror("ioctl() start sampling failed ");
              printf("Probably time was not set for the IP-VLBI board.\n");
              printf("Please set time using timesettk and try again.\n");
		goto end;
	}
	else {
		printf("ioctl() start sampling succeed\n");
	}
		printf("This is new version (2002-10-21) of sampleget\n");
	c = 0;
	dc=0.0;   // 2002-10-21
	f_c=0;    // 2002-10-21
	//while (c <=  allbyte) {
	while (1) {                   // 2002-10-21
	   int nbyte = sizeof(buf);   // nbyte = 8192

	   rv = read(fd_in, buf, nbyte);
	   if (rv == -1) {
	      perror("read() failed ");
	      goto end;
	   }
          //printf(" nbyte = %d\n",nbyte);   // debug
	   rv = write(fd_out, buf, rv);
	   c= c+ nbyte;
	/* add on 2002-10-21 */
		dc+=(double)nbyte;
		if( dc > dallbyte) {   // sampling end
			goto exithere;
		}
		if(c >  FILEMAXSIZE) { // newfile creation
			c=0;
			close(fd_out);
			f_c++;
			// new file name creation     XXXX.datN   where N=1,2,3......
			strcpy(outname2,outfile);
			sprintf(cbuf,"%d\0",f_c);
			strcat(outname2,cbuf);
			printf("outfile %d %s\n",f_c,outname2);  //debug
            /* output file open */
	        fd_out = open(outname2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
	        if (fd_out == -1) {
		       perror("output file open() error");
		       goto end;
	       }
		}
			
	}

exithere:
       /* sampling stop */

	rv = ioctl(fd_in, TDSIO_SAMPLING_STOP);
	if (rv == -1) {
		perror("ioctl() stop sampling failed ");
		goto end;
	}
	else {
		printf("ioctl() stop sampling succeed\n");
	}

	close(fd_out);

 end:
	close(fd_in);

	return rv;
}
		
		
		
int sampleget2(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode)
{
/*
                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ݁@iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       5:  3+4  for debug purpose ꊇt@C debug.dat 쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
	char dev[] = "/dev/tds0";
	int fd_in;
	int fd_out, fd_out_tmp;
	mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
	int rv, rv2, rv3, rv2s;
	unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
	int i,h,m,s;
	int secforce;
	int headbit=64;  // header bit number  for a new sampler board
	//int headbit=32;  // header bit number  for a old sampler board
	long int allbyte;     // TvOoCg
	long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
	long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
	long int c, c2;
	unsigned int sampling1, freq, width;
	int ch;
	int sec_counter;    // second counter for tempolary file creation
	int sec_counter_max;
	int fmode;         // file out mode
	int endflg, nbyte, nfile;
	char* namnow="sampler.now"; //1sec file name sampling out now 
	char* namlast="sampler.dat"; //1sec file name sampling out just finished 
	char tmpnow[80],tmplast[80];
	char tmpfile1[80],tmpfile2[80], outfile2[80];
	char fname1[20],fname2[20];
	char filetable[1000][80];  // 1sec file name container  
	int nfilemax;
	int fvalid;   // 1 sec file number exceeds 3 then set 1 
	int fpos;
	int ierr;
	unsigned char bit64[8];  // for header check
	int hspatn, hiok, hsmplbit, hsfreq, hnumch, hhh,hmm,hss;
	long int hseconds;
	char* fdebug="debug.dat";
	FILE *fin;
	
	u_int8_t sfreq_t, sbit_t, numch_t;
	u_int8_t sampling;
	u_int32_t buf[BUFSIZ * 2];
	
	nfilemax=1000;
	sec_counter_max=1000;  // sec_counter reset if exceeds this value
	fvalid=0;

	//printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI

/*
	printf(" span = %d\n",span);    // debug
	printf(" sfreq= %d\n",sfreq);   // debug
	printf(" adbit= %d\n",adbit);   // debug
	printf(" numch= %d\n",numch);   // debug
*/
	/* File out mode check */
	if(mode <=0 || mode > 4) {
		fmode=1;
	} else {
		fmode=mode;
	}
	if(mode == 5) {
		fmode=3;
	}
	if(mode == 6 || mode ==7 ) {
		fmode=2;
		nfilemax=10;
		sec_counter_max=10;
	}

	/* sampling duration check */
	if (span <= 0) {
		printf(" parameter span (duration in sec) should be positive!\n");
		// nothing to do
		return -1;
	}


	/* sampler open */
	fd_in = open(dev, O_RDONLY);
	//fd_in = open("/dev/tds0", O_RDONLY);
	if (fd_in == -1) {
		perror("device open() error ");
		return -1;
	}

	/* output file open */
	if(fmode == 1 || fmode ==3){
		fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
		if (fd_out == -1) {
			perror("output file open() error");
			goto end;
		}
	}
	sec_counter=0;
	/* tempolary file name creation */
	strcpy(tmpnow,dirtemp);
	strcpy(tmplast,dirtemp);
	strcat(tmpnow,namnow);
	strcat(tmplast,namlast);
                       	
	//sprintf(fname1,"smp%04d.now\0",sec_counter);  
	sprintf(fname2,"smp%04d.dat\0",sec_counter);  
	//strcat(tmpfile1,fname1);
	strcpy(tmpfile2,dirtemp);
	strcat(tmpfile2,fname2);
	
	/* tempolary output file open */
	if(mode !=7 ){
		
		if(fmode == 2 || fmode ==3 || fmode == 4){
			fd_out_tmp = open(tmpnow, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
			if (fd_out_tmp == -1) {
				perror("temprary output file open() error");
				goto end;
			}
		}
	}
       /* sampling frequency set */

       if      (sfreq ==  40)  { sfreq_t =  TDS_SAMPLING_40KHZ; }
       else if (sfreq == 100)  { sfreq_t =  TDS_SAMPLING_100KHZ; }
       else if (sfreq == 200)  { sfreq_t =  TDS_SAMPLING_200KHZ; }
       else if (sfreq == 500)  { sfreq_t =  TDS_SAMPLING_500KHZ; }
       else if (sfreq ==   1)  { sfreq_t =  TDS_SAMPLING_1MHZ; }
       else if (sfreq ==   2)  { sfreq_t =  TDS_SAMPLING_2MHZ; }
       else if (sfreq ==   4)  { sfreq_t =  TDS_SAMPLING_4MHZ; }
       else if (sfreq ==   8)  { sfreq_t =  TDS_SAMPLING_8MHZ; }
       else if (sfreq ==  16)  { sfreq_t =  TDS_SAMPLING_16MHZ; }
       else { 
	   printf(" parameter sfreq  (sampling frequency) must be either one of followings:\n");
	   printf("              40,100,200,500 (for kHz)\n");
	   printf("              1,2,4,8,16 (for MHz)\n");
          return -1;
       }
      
       /* AD resolution set */
       if      (adbit ==  1)  { sbit_t =  TDS_SAMPLING_1BIT; }
       else if (adbit ==  2)  { sbit_t =  TDS_SAMPLING_2BIT; }
       else if (adbit ==  4)  { sbit_t =  TDS_SAMPLING_4BIT; }
       else if (adbit ==  8)  { sbit_t =  TDS_SAMPLING_8BIT; }
       else { 
	   printf(" parameter adbit (A/D resolution) must be either one of followings:\n");
	   printf("              1,2,4,8\n");
          return -1;
       }

       /* number of channels */
       if      (numch ==  1)  { numch_t =  TDS_SAMPLING_1CH; }
       else if (numch ==  4)  { numch_t =  TDS_SAMPLING_4CH; }
       else { 
	   printf(" parameter numch (number of channels) must be either one of followings:\n");
	   printf("              1,4\n");
          return -1;
       }

       /* sampling parameters set */
       sampling =  sfreq_t | sbit_t | numch_t;

       //if (sfreq >= 40) { bitsec=sfreq*1000 + headbit ;}   
       //else { bitsec=sfreq*1000*1000 + headbit ;}
       if (sfreq >= 40) { bitsec=sfreq*1000 ;}          //2002-9-15
       else { bitsec=sfreq*1000*1000 ;}                 //2002-9-15

     /* sampling byte number calc */
		//bitsec=bitsec*adbit*numch;   // bit number per second
		bitsec=(bitsec*adbit*numch)+headbit;   // bit number per second  !! 2002-9-15

       bytesec=bitsec/8;
       allbyte=bytesec*span;

       /* File maximum bytes check */
       if(mode !=6 && mode !=7 ){
       		if (allbyte > FILEMAXSIZE || allbyte < 0){
         	 	allbyte= FILEMAXSIZE;
          		secforce=allbyte/bytesec;
         
          		allbyte=secforce*bytesec;
          		printf(" # of bytes force to set to %d Bytes because it exceeds %d Bytes\n",
              	allbyte,FILEMAXSIZE);  // debug
         	 	printf(" Obserbasation span (sec) reduced to %d\n",secforce);  // debug
        	}
       }
       printf(" bitsec  = %d\n",bitsec);  // debug
       printf(" bytesec = %d\n",bytesec);  // debug
       printf(" allbyte = %d\n",allbyte);  // debug

	//sampling = TDS_SAMPLING_4MHZ | TDS_SAMPLING_1BIT | TDS_SAMPLING_1CH;

	rv = ioctl(fd_in, TDSIO_SET_SAMPLING, &sampling);
	if (rv == -1) {
	   perror("ioctl() sampling set failed ");
	   goto end;
	}
	else {
	   printf("ioctl() sampling set succeed\n");
	}


       /* get sampling parameters from a board */

	rv = ioctl(fd_in,TDSIO_GET_SAMPLING,&sampling1);
	if (rv == -1) {
		perror("ioctl() get sampling parameter failed ");
		goto end;
	}
	else {
		printf("ioctl() get sampling parameter succeed\n");
		freq = TDS_GET_SAMP_FREQ(sampling1);
		width = TDS_GET_SAMP_WIDTH(sampling1);
		ch = TDS_GET_SAMP_CH(sampling1);
		if(freq == TDS_SAMPLING_40KHZ)
			freq = 40;
		if(freq == TDS_SAMPLING_100KHZ)
			freq = 100;
		if(freq == TDS_SAMPLING_200KHZ)
			freq = 200;
		if(freq == TDS_SAMPLING_500KHZ)
			freq = 500;
		if(freq == TDS_SAMPLING_1MHZ)
			freq = 1000;
		if(freq == TDS_SAMPLING_2MHZ)
			freq = 2000;
		if(freq == TDS_SAMPLING_4MHZ)
			freq = 4000;
		if(freq == TDS_SAMPLING_8MHZ)
			freq = 8000;
		if(freq == TDS_SAMPLING_16MHZ)
			freq = 16000;
		if(width == TDS_SAMPLING_1BIT)
			width = 1;
		if(width == TDS_SAMPLING_2BIT)
			width = 2;
		if(width == TDS_SAMPLING_4BIT)
			width = 4;
		if(width == TDS_SAMPLING_8BIT)
			width = 8;
		if(ch == TDS_SAMPLING_4CH)
			ch = 4;
		else
			ch =1;
		printf("sampling setting is %d kHz %d BIT %d CH\n",freq,width,ch);
	}	



       /* board time get */
 /*
	rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
	if (rv == -1) {
		perror("ioctl() time get failed ");
		return -1;
	}
       day=TDS_GET_DAYS(time);
       sec=TDS_GET_SEC(time);
       sec2hms(sec,&h,&m,&s);
	//printf("get count day from device [%5d]\n",TDS_GET_DAYS(time));
	//printf("get count sec from device [%5d]\n",TDS_GET_SEC(time));
 	printf("%03d %02d:%02d:%02d\n",day,h,m,s);
 */

       
	rv = ioctl(fd_in, TDSIO_BUFFER_CLEAR);   // {[hFIFÕNA[
	if (rv == -1) {
		perror("ioctl() FIFO clear failed ");
		goto end;
	}
	else {
		printf("ioctl() FIFO clear succeed\n");
	}
/*       
	rv = ioctl(fd_in, TDSIO_SYNC_1PPS);           // Poorւ̓BV{[h(2002.3ȍ~)ł
	if (rv == -1) {                               // ȂĂ̍ŏɂPΗǂ
		perror("ioctl() 1pps sync failed ");   //  (Ȃǂj
		goto end;
	}
	else {
		printf("ioctl() 1pps sync succeed\n");
	}
*/
/*	rv = ioctl(fd_in, TDSIO_SYNC_TIME);            // O͎͂gpȂ
	if (rv == -1) {
		perror("ioctl() time sync failed ");
		goto end;
	}
	else {
		printf("ioctl() time sync succeed\n");
	}
*/

       /* sampling start */

	rv = ioctl(fd_in, TDSIO_SAMPLING_START);
	if (rv == -1) {
		perror("ioctl() start sampling failed ");
              printf("Probably time was not set for the IP-VLBI board.\n");
              printf("Please set time using timesettk and try again.\n");
		goto end;
	}
	else {
		printf("ioctl() start sampling succeed\n");
	}

	c = 0;
	c2= 0;
	endflg=0;
	nfile=0;
	nbyte = sizeof(buf);   // nbyte = 8192
	//while (c < BUFSIZ * BUFSIZ) {
	while (1) {

		rv = read(fd_in, buf, nbyte);
		if (rv == -1) {
			perror("read() failed ");
			goto end;
		}
		if(rv != nbyte) {printf("read byte # difference %d\n",rv);}
		//printf(" nbyte = %d\n",nbyte);   // debug
		/* monitor 1st 64bit data */
		if(c == 0) {
		    printf("%x %x \n",*(buf), *(buf+1));
		}
		
		c += rv;      // already read byte number
		//printf(" nbyte,rv,c  %d %d %d\n",nbyte,rv,c);   // debug
		if(mode !=6 && mode !=7 ){
			if( c >= allbyte ){
				rv3=c-allbyte;
				rv2=rv-rv3;
				endflg=1;  // end flag set
				if(fmode == 1 || fmode ==3){
					rv2 = write(fd_out, buf, rv2);
					close(fd_out);
				}
			} else {
				if(fmode == 1 || fmode ==3){
					rv = write(fd_out, buf, rv);
				}
			}
		}
			
		if(fmode == 2 || fmode ==3 || fmode == 4){
			c2+=rv;
			if(c2 >= bytesec) {
				rv3=c2-bytesec;
			
				rv2=rv-rv3;
				//printf("1st c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  // debug
				if(mode !=7 ){
					rv2=write(fd_out_tmp,buf,rv2);
					/* tempolary file update */
					close(fd_out_tmp);
					if(fvalid == 1){
						fpos=nfile-1;
						if(fpos < 0){ fpos=fpos+nfilemax;}
					
						//printf("%d %s\n",fpos,filetable[fpos]);
						/* folowing is not necessary for FreeBSD */
					/*
						if((ierr=remove(filetable[fpos])) <0){
						if(ierr != -1 ) perror("File remove error");
						}
					*/
						if (rename(tmplast,filetable[fpos]) <0) {
						perror("Rename tmplast error");
						}
					}else{
						if(nfile >=0) fvalid=1;
					}
				
					/* folowing (remove) is not necessary for FreeBSD */
					/*
					if((ierr=remove(tmplast)) <0){
				    if(ierr != -1 ) perror("File remove error");
					}
					*/
				
					if (rename(tmpnow,tmplast) <0){
						perror("File tmpnow rename error");
					}
				
				}
				strcpy(filetable[nfile],tmpfile2); // save file name info
				
				//printf("nfile %d   %s %s\n",nfile,filetable[nfile],tmpfile2);
				nfile++;
				if(nfile >= nfilemax) nfile=0;
				/* new templary file nmae creation */
				sec_counter++;
				if(sec_counter >= sec_counter_max) sec_counter=0;
				//sprintf(fname1,"smp%04d.now\0",sec_counter);  
				sprintf(fname2,"smp%04d.dat\0",sec_counter);  
				//strcpy(tmpfile1,dirtemp);
				//strcat(tmpfile1,fname1);
				strcpy(tmpfile2,dirtemp);
				strcat(tmpfile2,fname2);
				
				if(endflg !=1 ){
					if(mode !=7 ){
						/* tempolary output file open */
						//fd_out_tmp = open(tmpfile1, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
						fd_out_tmp = open(tmpnow, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
						if (fd_out_tmp == -1) {
							perror("temprary output file open() error");
							goto end;
						}
					}
					/* rest of data write */
					if(rv3 > 0) {
						rv2s=rv2/sizeof(u_int32_t);
						if(mode !=7 ){
							rv3=write(fd_out_tmp,buf+rv2s,rv3);
						}
						/* monitor 1st 64bit data */
						printf("%x %x \n",*(buf+rv2s), *(buf+rv2s+1));
						
						/* synck pattern check (this is too heavy for sampling gt 1MHz (no more use) */
						/*
						strncpy(bit64,(char *)(buf+rv2s),8);
						headerchkn(bit64,&hiok,&hspatn,&hsmplbit,&hsfreq,&hnumch,
							&hseconds,&hhh,&hmm,&hss);
						if (hiok == 0) {  // sync detection
							printf("Sync OK!!\n");
							printf("A/D(bits) %d  CHs %d  SFreq(kHz) %d",hsmplbit,hnumch, hsfreq);
							printf("  Time %02d:%02d:%02d  sec %d\n",hhh,hmm,hss,hseconds);
						} else {
							printf("First 64bit is not header block!\n");
						}
						*/
					}
						//printf("after  c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  // debug
					c2=rv3;
					//printf("final  c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  //debug
				}
			} else {
				if(mode !=7 ){
					rv2=write(fd_out_tmp,buf,rv);
				}
			}
		}
			
		if(endflg == 1) goto loopexit;
			
	}

loopexit:

       /* sampling stop */

	rv = ioctl(fd_in, TDSIO_SAMPLING_STOP);
	if (rv == -1) {
		perror("ioctl() stop sampling failed ");
		goto end;
	}
	else {
		printf("ioctl() stop sampling succeed\n");
	}
	
 end:
	close(fd_in);
	
	if(mode !=7 ){
		
	if(fmode == 2 || fmode ==3 || fmode == 4){
		if(fvalid == 1){
			fpos=nfile-1;
			if(fpos < 0) fpos=fpos+nfilemax;
			/*
			if(remove(filetable[fpos]) <0)
			perror("File remove error");
			*/
			/* just rename */
		//	if (rename(tmplast,filetable[fpos]) <0) 
		//		perror("Rename tmplast error");
			
			/* Copy file to leave last file name */
			fd_out = open(filetable[fpos], O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
			if (fd_out == -1) {
				perror("output file open() error");
				goto end2;
			}
			if((fin = fopen(tmplast, "rb"))==NULL){
				perror("Data file open error!\n");
				goto end2;
			}
			while(1){
				rv = fread(buf,1,nbyte,fin);
				if (rv == -1) {
					perror("read() failed ");
					goto end2;
				}
				rv2=write(fd_out,buf,rv);
				if (feof(fin) !=0)  // Reach EOF
				{
					fclose(fin);
					goto exit2;
				}
			}
		exit2:;
			
			close(fd_out);		
		}
	}
		
	}
	//close(fd_out);
	//close(fd_out_tmp);
	//if (rename(tmpfile1,tmpfile2) <0) 
	//	perror("Rename error");
	
	/* 1sec data file merges into one file big file */
	
	if(fmode == 4 || mode ==5) {  
		printf("File merging .....\n");
		if(mode == 5) {  // for debug
			strcpy(outfile2,dirtemp);
			strcat(outfile2,fdebug);
		} else {
			strcpy(outfile2,outfile);
		}
		printf("File merging into  %s\n",outfile2);
		
		fd_out = open(outfile2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
		if (fd_out == -1) {
			perror("output file open() error");
			goto end2;
		}
		for(i=0; i<nfile; i++){
			strcpy(tmpfile1,filetable[i]);
			printf("%d %d : %s\n",nfile,i+1,tmpfile1);
			if((fin = fopen(tmpfile1, "rb"))==NULL){
				perror("Data file open error!\n");
				goto end2;
			}
			while(1){
				rv = fread(buf,1,nbyte,fin);
				if (rv == -1) {
					perror("read() failed ");
					goto end2;
				}
				rv2=write(fd_out,buf,rv);
				if (feof(fin) !=0)  // Reach EOF
				{
					fclose(fin);
					goto exit1;
				}
			}
		exit1:;
		}
		close(fd_out);
	}

 end2:;
	return rv;
}



int sampleget3(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode)
{
/*      sampleget2@̉ǔ

                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ݁@iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       5:  3+4  for debug purpose ꊇt@C debug.dat 쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
	char dev[] = "/dev/tds0";
	int fd_in;
	int fd_out, fd_out_tmp;
	mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
	int rv, rv2, rv3, rv2s;
	unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
	int i,h,m,s;
	int secforce;
	int headbit=64;  // header bit number  for a new sampler board
	//int headbit=32;  // header bit number  for a old sampler board
	long int allbyte;     // TvOoCg
	long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
	long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
	long int c, c2;
	unsigned int sampling1, freq, width;
	int ch;
	int sec_counter;    // second counter for tempolary file creation
	int sec_counter_max;
	int fmode;         // file out mode
	int endflg, nbyte, nfile;
	char* namnow="sampler.now"; //1sec file name sampling out now 
	char* namlast="sampler.dat"; //1sec file name sampling out just finished 
	char tmpnow[80],tmplast[80];
	char tmpfile1[80],tmpfile2[80], outfile2[80];
	char fname1[20],fname2[20];
	char filetable[1000][80];  // 1sec file name container  
	int nfilemax;
	int fvalid;   // 1 sec file number exceeds 3 then set 1 
	int fpos;
	int ierr;
	unsigned char bit64[8];  // for header check
	int hspatn, hiok, hsmplbit, hsfreq, hnumch, hhh,hmm,hss;
	long int hseconds;
	char* fdebug="debug.dat";
	FILE *fin;
	
	u_int8_t sfreq_t, sbit_t, numch_t;
	u_int8_t sampling;
	u_int32_t buf[BUFSIZ * 2];
	
	nfilemax=1000;
	sec_counter_max=1000;  // sec_counter reset if exceeds this value
	fvalid=0;

	//printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI

/*
	printf(" span = %d\n",span);    // debug
	printf(" sfreq= %d\n",sfreq);   // debug
	printf(" adbit= %d\n",adbit);   // debug
	printf(" numch= %d\n",numch);   // debug
*/
	/* File out mode check */
	if(mode <=0 || mode > 4) {
		fmode=1;
	} else {
		fmode=mode;
	}
	if(mode == 5) {
		fmode=3;
	}
	if(mode == 6 || mode ==7 ) {
		fmode=2;
		nfilemax=10;
		sec_counter_max=10;
	}

	/* sampling duration check */
	if (span <= 0) {
		printf(" parameter span (duration in sec) should be positive!\n");
		// nothing to do
		return -1;
	}


	/* output file open */
	if(fmode == 1 || fmode ==3){
		fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
		if (fd_out == -1) {
			perror("output file open() error");
			goto end;
		}
	}
	sec_counter=0;
	/* tempolary file name creation */
	strcpy(tmpnow,dirtemp);
	strcpy(tmplast,dirtemp);
	strcat(tmpnow,namnow);
	strcat(tmplast,namlast);
                       	
	//sprintf(fname1,"smp%04d.now\0",sec_counter);  
	sprintf(fname2,"smp%04d.dat\0",sec_counter);  
	//strcat(tmpfile1,fname1);
	strcpy(tmpfile2,dirtemp);
	strcat(tmpfile2,fname2);
	
	/* tempolary output file open */
	if(mode !=7 ){
		
		if(fmode == 2 || fmode ==3 || fmode == 4){
			fd_out_tmp = open(tmpnow, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
			if (fd_out_tmp == -1) {
				perror("temprary output file open() error");
				goto end;
			}
		}
	}


    /* sampling set and start sampling */
    if((rv=ini_and_start_sampler(&fd_in, sfreq, adbit, numch, &bitsec))<0) {
         goto end2;
    }
    //if((rv=ini_sampler(&fd_in, sfreq, adbit, numch, &bitsec))<0) {
    //     goto end2;
    //}

     bytesec=bitsec/8;
     allbyte=bytesec*span;

     /* File maximum bytes check */
     if(mode !=6 && mode !=7 ){
     	if (allbyte > FILEMAXSIZE || allbyte < 0){
       	 	allbyte= FILEMAXSIZE;
          	secforce=allbyte/bytesec;
         
          	allbyte=secforce*bytesec;
          	printf(" # of bytes force to set to %d Bytes because it exceeds %d Bytes\n",
            allbyte,FILEMAXSIZE);  // debug
         	printf(" Obserbasation span (sec) reduced to %d\n",secforce);  // debug
        }
	}
	printf(" bitsec  = %d\n",bitsec);  // debug
	printf(" bytesec = %d\n",bytesec);  // debug

	printf(" allbyte = %d\n",allbyte);  // debug
	
	//rv=start_sampler(&fd_in);
	//if(rv < 0) goto end;

	c = 0;
	c2= 0;
	endflg=0;
	nfile=0;
	nbyte = sizeof(buf);   // nbyte = 8192
	//while (c < BUFSIZ * BUFSIZ) {
	while (1) {
		
		rv = read(fd_in, buf, nbyte);
		if (rv == -1) {
			perror("read() failed ");
			goto end;
		}
		if(rv != nbyte) {printf("read byte # difference %d\n",rv);}
		//printf(" nbyte = %d\n",nbyte);   // debug
		
		/* monitor 1st 64bit data */
		if(c == 0) {
		    printf("%x %x ",*(buf), *(buf+1));
			headerchkn((unsigned char*)(buf),&hiok,&hspatn,&hsmplbit,&hsfreq,&hnumch,
					&hseconds,&hhh,&hmm,&hss);
			if (hiok == 0) {  // sync detection
				printf("OK ");
				printf("%dbit %dch %dkHz",hsmplbit,hnumch, hsfreq);
				printf(" %02d:%02d:%02d %d\n",hhh,hmm,hss,hseconds);
			} else {
				printf("First 64bit is not header block!\n");
			}
		}
		c += rv;      // already read byte number
		//printf(" nbyte,rv,c  %d %d %d\n",nbyte,rv,c);   // debug
		if(mode !=6 && mode !=7 ){
			if( c >= allbyte ){
				rv3=c-allbyte;
				rv2=rv-rv3;
				endflg=1;  // end flag set
				if(fmode == 1 || fmode ==3){
					rv2 = write(fd_out, buf, rv2);
					close(fd_out);
				}
			} else {
				if(fmode == 1 || fmode ==3){
					rv = write(fd_out, buf, rv);
				}
			}
		}
			
		if(fmode == 2 || fmode ==3 || fmode == 4){
			c2+=rv;
			if(c2 >= bytesec) {
				rv3=c2-bytesec;
			
				rv2=rv-rv3;
				//printf("1st c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  // debug
				if(mode !=7 ){
					rv2=write(fd_out_tmp,buf,rv2);
					/* tempolary file update */
					close(fd_out_tmp);
					if(fvalid == 1){
						fpos=nfile-1;
						if(fpos < 0){ fpos=fpos+nfilemax;}
					
						//printf("%d %s\n",fpos,filetable[fpos]);
						/* folowing is not necessary for FreeBSD */
					/*
						if((ierr=remove(filetable[fpos])) <0){
						if(ierr != -1 ) perror("File remove error");
						}
					*/
						if (rename(tmplast,filetable[fpos]) <0) {
							perror("Rename tmplast error");
						}
					}else{
						if(nfile >=0) fvalid=1;
					}
				
					/* folowing (remove) is not necessary for FreeBSD */
					/*
					if((ierr=remove(tmplast)) <0){
				    if(ierr != -1 ) perror("File remove error");
					}
					*/
				
					if (rename(tmpnow,tmplast) <0){
						perror("File tmpnow rename error");
					}
				
				}
				strcpy(filetable[nfile],tmpfile2); // save file name info
				
				//printf("nfile %d   %s %s\n",nfile,filetable[nfile],tmpfile2);
				nfile++;
				if(nfile >= nfilemax) nfile=0;
				/* new templary file nmae creation */
				sec_counter++;
				if(sec_counter >= sec_counter_max) sec_counter=0;
				//sprintf(fname1,"smp%04d.now\0",sec_counter);  
				sprintf(fname2,"smp%04d.dat\0",sec_counter);  
				//strcpy(tmpfile1,dirtemp);
				//strcat(tmpfile1,fname1);
				strcpy(tmpfile2,dirtemp);
				strcat(tmpfile2,fname2);
				
				if(endflg !=1 ){
					if(mode !=7 ){
						/* tempolary output file open */
						//fd_out_tmp = open(tmpfile1, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
						fd_out_tmp = open(tmpnow, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
						if (fd_out_tmp == -1) {
							perror("temprary output file open() error");
							goto end;
						}
					}
					/* rest of data write */
					if(rv3 > 0) {
						rv2s=rv2/sizeof(u_int32_t);
						if(mode !=7 ){
							rv3=write(fd_out_tmp,buf+rv2s,rv3);
						}
						/* monitor 1st 64bit of second  data */
						printf("%x %x ",*(buf+rv2s), *(buf+rv2s+1));
						
						/* synck pattern check  */
						
						//strncpy(bit64,(char *)(buf+rv2s),8);
						//headerchkn(bit64,&hiok,&hspatn,&hsmplbit,&hsfreq,&hnumch,
						headerchkn((unsigned char*)(buf+rv2s),&hiok,&hspatn,&hsmplbit,&hsfreq,&hnumch,
							&hseconds,&hhh,&hmm,&hss);
						if (hiok == 0) {  // sync detection
							printf("OK ");
							printf("%dbit %dch %dkHz",hsmplbit,hnumch, hsfreq);
							printf(" %02d:%02d:%02d %d\n",hhh,hmm,hss,hseconds);
						} else {
							printf("First 64bit is not header block!\n");
							/* check previous data at least 10 times*/
						}
					}
						//printf("after  c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  // debug
					c2=rv3;
					//printf("final  c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  //debug
				}
			} else {
				if(mode !=7 ){
					rv2=write(fd_out_tmp,buf,rv);
				}
			}
		}
			
		if(endflg == 1) goto loopexit;
			
	}

loopexit:

       /* sampling stop */
end:
	rv = stop_sampler(&fd_in);
	
	if(mode !=7 ){
		
	if(fmode == 2 || fmode ==3 || fmode == 4){
		if(fvalid == 1){
			fpos=nfile-1;
			if(fpos < 0) fpos=fpos+nfilemax;
			/*
			if(remove(filetable[fpos]) <0)
			perror("File remove error");
			*/
			/* just rename */
		//	if (rename(tmplast,filetable[fpos]) <0) 
		//		perror("Rename tmplast error");
			
			/* Copy file to leave last file name */
			fd_out = open(filetable[fpos], O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
			if (fd_out == -1) {
				perror("output file open() error");
				goto end2;
			}
			if((fin = fopen(tmplast, "rb"))==NULL){
				perror("Data file open error!\n");
				goto end2;
			}
			while(1){
				rv = fread(buf,1,nbyte,fin);
				if (rv == -1) {
					perror("read() failed ");
					goto end2;
				}
				rv2=write(fd_out,buf,rv);
				if (feof(fin) !=0)  // Reach EOF
				{
					fclose(fin);
					goto exit2;
				}
			}
		exit2:;
			
			close(fd_out);
		}
	}
		
	}
	//close(fd_out);
	//close(fd_out_tmp);
	//if (rename(tmpfile1,tmpfile2) <0) 
	//	perror("Rename error");
	
	/* 1sec data file merges into one file big file */
	
	if(fmode == 4 || mode ==5) {  
		printf("File merging .....\n");
		if(mode == 5) {  // for debug
			strcpy(outfile2,dirtemp);
			strcat(outfile2,fdebug);
		} else {
			strcpy(outfile2,outfile);
		}
		printf("File merging into  %s\n",outfile2);
		
		fd_out = open(outfile2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
		if (fd_out == -1) {
			perror("output file open() error");
			goto end2;
		}
		for(i=0; i<nfile; i++){
			strcpy(tmpfile1,filetable[i]);
			printf("%d %d : %s\n",nfile,i+1,tmpfile1);
			if((fin = fopen(tmpfile1, "rb"))==NULL){
				perror("Data file open error!\n");
				goto end2;
			}
			while(1){
				rv = fread(buf,1,nbyte,fin);
				if (rv == -1) {
					perror("read() failed ");
					goto end2;
				}
				rv2=write(fd_out,buf,rv);
				if (feof(fin) !=0)  // Reach EOF
				{
					fclose(fin);
					goto exit1;
				}
			}
		exit1:;
		}
		close(fd_out);
	}

 end2:;
	return rv;
}
		
		

int sampleget4(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode)
{
/*      sampleget3 ̉ǔ  (₦VNp^[̌osj

                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       5:  3+4  for debug purpose ꊇt@C debug.dat 쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
	char dev[] = "/dev/tds0";
	int fd_in;
	int fd_out, fd_out_tmp;
	mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
	int rv, rv2, rv3, rv2s;
	unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
	int i,h,m,s;
	int secforce;
	int headbit=64;  // header bit number  for a new sampler board
	//int headbit=32;  // header bit number  for a old sampler board
	long int allbyte;     // TvOoCg
	long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
	long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
	long int c, c2;
	unsigned int sampling1, freq, width;
	int ch;
	int sec_counter;    // second counter for tempolary file creation
	int sec_counter_max;
	long int byteinter;   // inter header byte counter
	int rv32;
	int bytepos; //  byte position for start of sync pattern
	int fmode;         // file out mode
	int endflg, nbyte, nfile;
	int flag1sec;     // 1sec (sync) detection flag  1:detected
	int flag1st;
	char* namnow="sampler.now"; //1sec file name sampling out now 
	char* namlast="sampler.dat"; //1sec file name sampling out just finished 
	char tmpnow[80],tmplast[80];
	char tmpfile1[80],tmpfile2[80], outfile2[80];
	char fname1[20],fname2[20];
	char filetable[1000][80];  // 1sec file name container  
	int nfilemax;
	int fvalid;   // 1 sec file number exceeds 3 then set 1 
	int fpos;
	int ierr;
	unsigned char bit64[8];  // for header check
	int hspatn, hiok, hsmplbit, hsfreq, hnumch, hhh,hmm,hss;
	long int hseconds, seconds, secold;
	char* fdebug="debug.dat";
	FILE *fin;
	
	u_int8_t sfreq_t, sbit_t, numch_t;
	u_int8_t sampling;
	u_int32_t buf[BUFSIZ * 2], lastbuf;
	
	nfilemax=1000;
	sec_counter_max=1000;  // sec_counter reset if exceeds this value
	fvalid=0;
	flag1sec=0;
	flag1st=0;
	bytepos=0;
	byteinter=0;
	//lastbuf = (u_int32_t *)malloc(sizeof(u_int32_t));
	//printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI

/*
	printf(" span = %d\n",span);    // debug
	printf(" sfreq= %d\n",sfreq);   // debug
	printf(" adbit= %d\n",adbit);   // debug
	printf(" numch= %d\n",numch);   // debug
*/
	/* File out mode check */
	if(mode <=0 || mode > 4) {
		fmode=1;
	} else {
		fmode=mode;
	}
	if(mode == 5) {
		fmode=3;
	}
	if(mode == 6 || mode ==7 ) {
		fmode=2;
		nfilemax=10;
		sec_counter_max=10;
	}

	/* sampling duration check */
	if (span <= 0) {
		printf(" parameter span (duration in sec) should be positive!\n");
		// nothing to do
		return -1;
	}


	/* output file (1 big file) open */
	if(fmode == 1 || fmode ==3){
		fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
		if (fd_out == -1) {
			perror("output file open() error");
			goto end;
		}
	}
	sec_counter=0;
	/* tempolary file (for 1 sec data write name) creation */
	strcpy(tmpnow,dirtemp);
	strcpy(tmplast,dirtemp);
	strcat(tmpnow,namnow);
	strcat(tmplast,namlast);
                       	
	//sprintf(fname1,"smp%04d.now\0",sec_counter);  
	sprintf(fname2,"smp%04d.dat\0",sec_counter);  
	//strcat(tmpfile1,fname1);
	strcpy(tmpfile2,dirtemp);
	strcat(tmpfile2,fname2);
	
	/* tempolary output file open */
	if(mode !=7 ){
		
		if(fmode == 2 || fmode ==3 || fmode == 4){
			fd_out_tmp = open(tmpnow, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
			if (fd_out_tmp == -1) {
				perror("temprary output file open() error");
				goto end;
			}
		}
	}


    /* sampling set and start sampling */
    if((rv=ini_and_start_sampler(&fd_in, sfreq, adbit, numch, &bitsec))<0) {
         goto end2;
    }

     bytesec=bitsec/8;
     allbyte=bytesec*span;

     /* File maximum bytes check */
     if(mode !=6 && mode !=7 ){
     	if (allbyte > FILEMAXSIZE || allbyte < 0){
       	 	allbyte= FILEMAXSIZE;
          	secforce=allbyte/bytesec;
         
          	allbyte=secforce*bytesec;
          	printf(" # of bytes force to set to %d Bytes because it exceeds %d Bytes\n",
            allbyte,FILEMAXSIZE);  // debug
         	printf(" Obserbasation span (sec) reduced to %d\n",secforce);  // debug
        }
	}
	printf(" bitsec  = %d\n",bitsec);  // debug
	printf(" bytesec = %d\n",bytesec);  // debug

	printf(" allbyte = %d\n",allbyte);  // debug
	
	//rv=start_sampler(&fd_in);
	//if(rv < 0) goto end;

	c = 0;   // byte counter for one big file
	c2= 0;   
	endflg=0;
	nfile=0;
	nbyte = sizeof(buf);   // nbyte = 8192
	//while (c < BUFSIZ * BUFSIZ) {
	while (1) {
		
		rv = read(fd_in, buf, nbyte);
		if (rv == -1) {
			perror("read() failed ");
			goto end;
		}
		if(rv != nbyte) {printf("read byte # difference %d\n",rv);}
		//printf(" nbyte = %d\n",nbyte);   // debug
		
		/* sync pattern check */
		rv32=rv/sizeof(u_int32_t);
		if(c > 0) {
			if(lastbuf==0xFFFFFFFF && ((buf[0] & 0xFF000000)==0x8B000000)) { // this is sync pattern
				seconds=(long int)(buf[0] & 0x1FFFF);
				printf("Sync detected  byteinter %d  seconds %d\n",byteinter, seconds);
				if( secold+1 != seconds){ // time error
					if((secold != 86399) && (seconds != 0)){
					     printf("Time increment error!\n");
					}
				}
				if(bytesec != byteinter){
					printf("%d bytes data missed\n",bytesec-byteinter);
				}
				bytepos=-4;
				flag1sec=1;
				secold=seconds;
				byteinter=0;
			} 
			byteinter+=4;
		}
			
		for(i=0; i<rv32-1; i++){
			if(buf[i]==0xFFFFFFFF && ((buf[i+1] & 0xFF000000)==0x8B000000)) { // this is sync pattern
				seconds=(long int)(buf[i+1] & 0x1FFFF);
				printf("Sync detected  byteinter %d  seconds %d \n",byteinter, seconds);
				if( c > 0 && ( secold+1 != seconds)){ // time error
					if((secold != 86399) && (seconds != 0)){
						printf("Time increment error!\n");
					}
				}
				if(c > 0 && (bytesec != byteinter)){
					printf("%d bytes data missed\n",bytesec-byteinter);
				}
				bytepos=i*sizeof(u_int32_t);
				flag1sec=1;
				secold=seconds;
				byteinter=0;
			} 
			byteinter+=4;
		}
		lastbuf=buf[rv32-1];
		/*
		if(c == 0) {
		    printf("%x %x ",*(buf), *(buf+1));
			headerchkn((unsigned char*)(buf),&hiok,&hspatn,&hsmplbit,&hsfreq,&hnumch,
					&hseconds,&hhh,&hmm,&hss);
			if (hiok == 0) {  // sync detection
				printf("OK ");
				printf("%dbit %dch %dkHz",hsmplbit,hnumch, hsfreq);
				printf(" %02d:%02d:%02d %d\n",hhh,hmm,hss,hseconds);
			} else {
				printf("First 64bit is not header block!\n");
			}
		}
		*/
		c += rv;      // already read byte number
		//printf(" nbyte,rv,c  %d %d %d\n",nbyte,rv,c);   // debug
		if(mode !=6 && mode !=7 ){
			if( c >= allbyte ){
				rv3=c-allbyte;
				rv2=rv-rv3;
				endflg=1;  // end flag set
				if(fmode == 1 || fmode ==3){
					rv2 = write(fd_out, buf, rv2);
					close(fd_out);
				}
			} else {
				if(fmode == 1 || fmode ==3){
					rv = write(fd_out, buf, rv);
				}
			}
		} else {
			c=1;   // for inifinite operation for mode=6 or =7
		}
		
		/* every 1 sec file creation */
		if(fmode == 2 || fmode ==3 || fmode == 4){
			if(flag1st ==1 && flag1sec ==1 ) {
				rv3=rv-bytepos;
				rv2=bytepos;
				//printf("1st c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  // debug
				if(mode !=7){
					if(bytepos > -4 ) {
						if(flag1st != 0) c2=write(fd_out_tmp,&lastbuf,4);
					}
					if(bytepos > 0 ) {
					     rv2=write(fd_out_tmp,buf,rv2);
					}
					/* tempolary file update */
					close(fd_out_tmp);
					if(fvalid == 1){
						fpos=nfile-1;
						if(fpos < 0){ fpos=fpos+nfilemax;}
					
						//printf("%d %s\n",fpos,filetable[fpos]);
						/* folowing is not necessary for FreeBSD */
					/*
						if((ierr=remove(filetable[fpos])) <0){
						if(ierr != -1 ) perror("File remove error");
						}
					*/
						if (rename(tmplast,filetable[fpos]) <0) {
							perror("Rename tmplast error");
						}
					}else{
						if(nfile >=0) fvalid=1;
					}
				
					/* folowing (remove) is not necessary for FreeBSD */
					/*
					if((ierr=remove(tmplast)) <0){
				    if(ierr != -1 ) perror("File remove error");
					}
					*/
				
					if (rename(tmpnow,tmplast) <0){
						perror("File tmpnow rename error");
					}
				
				}
				strcpy(filetable[nfile],tmpfile2); // save file name info
				
				//printf("nfile %d   %s %s\n",nfile,filetable[nfile],tmpfile2);
				nfile++;
				if(nfile >= nfilemax) nfile=0;
				/* new templary file nmae creation */
				sec_counter++;
				if(sec_counter >= sec_counter_max) sec_counter=0;
				//sprintf(fname1,"smp%04d.now\0",sec_counter);  
				sprintf(fname2,"smp%04d.dat\0",sec_counter);  
				//strcpy(tmpfile1,dirtemp);
				//strcat(tmpfile1,fname1);
				strcpy(tmpfile2,dirtemp);
				strcat(tmpfile2,fname2);
				
				if(endflg !=1 ){
					if(mode !=7 ){
						/* tempolary output file open */
						//fd_out_tmp = open(tmpfile1, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
						fd_out_tmp = open(tmpnow, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
						if (fd_out_tmp == -1) {
							perror("temprary output file open() error");
							goto end;
						}
					}
					/* rest of data write */
					if(bytepos > 0) {
						rv2s=rv2/sizeof(u_int32_t);
						if(mode !=7 ){
							rv3=write(fd_out_tmp,buf+rv2s,rv3-4);
						}
					} else {
						if(mode !=7 ){
							rv3=write(fd_out_tmp,buf,rv-4);
						}
					}
						//printf("after  c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  // debug
					c2=rv3;
					//printf("final  c2,rv3,rv2   %d %d %d\n",c2,rv3,rv2);  //debug
				}
			} else {
				if(mode !=7 ){
					if(flag1st !=0) c2=write(fd_out_tmp,&lastbuf,4);
					rv2=write(fd_out_tmp,buf,rv-4);
				}
			}
			flag1sec=0; //flag reset
		}
		flag1st=1;
		if(endflg == 1) goto loopexit;
			
	}

loopexit:

       /* sampling stop */
end:
	rv = stop_sampler(&fd_in);
	
	if(mode !=7 ){
		
	if(fmode == 2 || fmode ==3 || fmode == 4){
		if(fvalid == 1){
			fpos=nfile-1;
			if(fpos < 0) fpos=fpos+nfilemax;
			/*
			if(remove(filetable[fpos]) <0)
			perror("File remove error");
			*/
			/* just rename */
		//	if (rename(tmplast,filetable[fpos]) <0) 
		//		perror("Rename tmplast error");
			
			/* Copy file to leave last file name */
			fd_out = open(filetable[fpos], O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
			if (fd_out == -1) {
				perror("output file open() error");
				goto end2;
			}
			if((fin = fopen(tmplast, "rb"))==NULL){
				perror("Data file open error!\n");
				goto end2;
			}
			while(1){
				rv = fread(buf,1,nbyte,fin);
				if (rv == -1) {
					perror("read() failed ");
					goto end2;
				}
				rv2=write(fd_out,buf,rv);
				if (feof(fin) !=0)  // Reach EOF
				{
					fclose(fin);
					goto exit2;
				}
			}
		exit2:;
			
			close(fd_out);
		}
	}
		
	}
	//close(fd_out);
	//close(fd_out_tmp);
	//if (rename(tmpfile1,tmpfile2) <0) 
	//	perror("Rename error");
	
	/* 1sec data file merges into one file big file */
	
	if(fmode == 4 || mode ==5) {  
		printf("File merging .....\n");
		if(mode == 5) {  // for debug
			strcpy(outfile2,dirtemp);
			strcat(outfile2,fdebug);
		} else {
			strcpy(outfile2,outfile);
		}
		printf("File merging into  %s\n",outfile2);
		
		fd_out = open(outfile2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
		if (fd_out == -1) {
			perror("output file open() error");
			goto end2;
		}
		for(i=0; i<nfile; i++){
			strcpy(tmpfile1,filetable[i]);
			printf("%d %d : %s\n",nfile,i+1,tmpfile1);
			if((fin = fopen(tmpfile1, "rb"))==NULL){
				perror("Data file open error!\n");
				goto end2;
			}
			while(1){
				rv = fread(buf,1,nbyte,fin);
				if (rv == -1) {
					perror("read() failed ");
					goto end2;
				}
				rv2=write(fd_out,buf,rv);
				if (feof(fin) !=0)  // Reach EOF
				{
					fclose(fin);
					goto exit1;
				}
			}
		exit1:;
		}
		close(fd_out);
	}

 end2:;
	return rv;
}
		
int ip_board_time(unsigned int *day, unsigned int *sec, int *hh, int *mm, int *ss)
{
     int fd_in,rv;
	 unsigned int time;
	 fd_in = open("/dev/tds0", O_RDONLY);  //foCX̃I[v
	 if (fd_in == -1) {
		perror("device open() error ");
		return -1;
	 }
	 //foCX玞̎擾 
	 rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
     if (rv == -1) {
		 perror("ioctl() time get failed ");
		 return -1;
	 }
     *day=TDS_GET_DAYS(time);
     *sec=TDS_GET_SEC(time);
     sec2hms(*sec,&(*hh),&(*mm),&(*ss));
	close(fd_in);  // ho|ukah{[hN[Y
	return 0;
}

#endif
