/**************************************************************/
/*                                                            */
/*   Program Name :  sampling                                 */
/*                                                            */
/*      Version:  0.00  2001-08-17                            */
/*                1.00  2002-05-26                            */
/*                                                            */
/*      Copyright (c) 2002 T.Kondo/CRL All Right Reserved     */
/*                                                            */
/**************************************************************/
/*

 ho|ukah ItCTvOvO
        iZbg͕ʂ̃\tgōs)
         by T.Kondo    2001.8.17
                1.0    2002.5.26

    点 sampling_n span sfreq adbit numch [filename]
          span  Wԁibj
                sfreq  TvOg
                       40,100,200,500  (kHz)
                       1,2,4,8,16      (MHz)
                adbit  `c\irbg)
                       1,2,4,8 
                numch  `l
                       1 ܂ 4
                filename -- f[^t@C
                      ftHgtds.data
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>
#include <sys/stat.h>
#ifdef linux
#include <sys/time.h>
#else
#include <time.h>
#endif
#include <sys/tdsio.h>

#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo)
#include "libipvlbi_board.h"  // IP-VLBITv[{[hp֐Q(by T.Kondo)



int main(int argc, char **argv)
{
	char outfile[60];
	char* dflt_fname="tds.data";
	int rv;
       int span, sfreq, adbit, numch;

	if(argc != 5 & argc !=6){
          printf("Usage: sampling span sfreq adbit numch [filename]\n");
          printf("\n");
          printf("         where  span ---- duration (sec)\n");
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           1,2,4,8,16 (for MHz)\n");
          printf("                adbit ---- A/D bit\n");
          printf("                           1,2,4,8\n");
          printf("                          default is 1\n");
          printf("                numch ---- number of channel\n");
          printf("                           1,4\n");
          printf("                          default is 1\n");
          printf("                filename ---- out file name\n");
          printf("                          default is tds.data\n");
          exit(0);
	}

	span = atoi(*(argv + 1 ));
	sfreq= atoi(*(argv + 2 ));
	if (argc>=4)
	{
	   adbit = atoi(*(argv + 3 ));
	}
       else
       {
          adbit=1;
       }

	if (argc>=5)
	{
	   numch = atoi(*(argv + 4 ));
	}
       else
       {
          numch=1;
       }

	if (argc>=6)
	{
          strcpy(outfile,*(argv+5));
	}
       else
       {
          strcpy(outfile,dflt_fname);
	}

	printf(" span    = %d\n",span);    // debug
       printf(" sfreq   = %d\n",sfreq);   // debug
       printf(" adbit   = %d\n",adbit);   // debug
       printf(" numch   = %d\n",numch);   // debug
       printf(" outfile = %s\n",outfile);   // debug

       rv=sampleget(outfile, span, sfreq, adbit, numch);

       printf("Data File is %s\n",outfile);

       return 0;
}
