/**************************************************************/
/*                                                            */
/*   Program Name :  speana2                                  */
/*                                                            */
/*      Version:  1.10  2003-04-21                            */
/*                                                            */
/*                                                            */
/*      Copyright (c) 2003 T.Kondo/CRL All Right Reserved     */
/*                                                            */
/**************************************************************/
/*
 ho|ukah{[h擾f[^̃XyNg ̂Q
        iItCj

          T.Kondo 2003.4.12
                  2003.4.21  sekibun𕉂̒lƂƌJԂԊuƂ悤ɂ

    点 speana2 filename [smode [sekibun1 [sekibun [soffset [comment [f1khz [f2khz]]]]]]]
          filename -- f[^t@C
                            0 Ƃƃt@C
                           tds.datag
               smode -- g\[h
                       0: 4096_@i1kHz@4MHzTvOjj
                       1: 4194304_@i1Hz@4MHzTvOj
               sekibun1  -- Pʐϕ(bPʁj
                       ftHg Pibj
               sekibun  -- SPʐϕ(bPʁj
                       ftHg ROOibj
                        ̒lƂƌJԂԊuibj
               soffset -- X^[gItZbgibj
                       ftHg Oibj
               comment  -- RgiOt㕔ɕ\jBXy[X܂܂ȂƁB
                           ȗꍇ͉b[h͂ɂȂ
                           FXy[X܂ރRg͉b[hœ͂邱ƁB
               f1khz  ---  p[őT[`giftHg0)
               f2khz  ---  p[őT[`giftHg̓rfIg)
*/

#include <cpgplot.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
//#include <sys/tdsio.h>
#include <math.h>
#ifdef linux
#include <sys/time.h>
#else
#include <time.h>
#endif
#include "libfft.h"
#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo)
//char dev[] = "/dev/tds0";

#ifndef PIRA
#define PIRA  1.745329252E-2    // PI/180  degree to radian
#endif
#ifndef PIDE
#define PIDE  57.29577951       // 180/PI radian to degree
#endif
#ifndef TWOPI
#define TWOPI 6.283185307       // 2PI
#endif
#ifndef PI
#define PI    3.141592653
#endif

/*    Offset from dB to dBm conversion from A/D multibit sampling data */ 
#define OFFSET1  16.0     //1 bit sampling full power convert to 0 dB (theoretical)
      /* following constants are provisional  (measured on 2002/5/18) */
#define OFFSET2   9.0     //2 bit sampling data offset measured at 200kHz for PC(vlbi11)
#define OFFSET4  -1.0     //4 bit sampling data offset measured at 200kHz for PC(vlbi11)
#define OFFSET8 -26.0     //8 bit sampling data offset measured at 200kHz for PC(vlbi11)

typedef struct ip_vlbi_file
{
	unsigned char bit32[4];
	unsigned char bit64[8];
	//char buf[65536];
	int sfreq;
	int icnt;   //  current position number
       char* fname; //I[vĂt@C
       float fsample;  //TvOg(Hz)
	int   adbit;  // ADrbg
	long int seconds; // 00h00m00šoߕb
       int hh, mm, ss;
	int spatn; // sync pattern
	int syncok; // =1 for 32bit all 1 detection
	int format; // =0 for old format , =1 for new format
	FILE *stream;
       fpos_t pos;
	int fh;
	int ch;
	int numch;
	int ierr;
       double dtime;
       unsigned int bytesread;
    int vflag, vflag_old;  // byte slip flag  added on 2003-02-14
                           //  if header sync detection is suceed
                           //     set to 1.  else 0
                           //   1: sync detection success 
                           //   0: sync detection error (may be byte slip)
                           //   vflag_old is the previous status
    long int dtime_vflag, dtime_vflag_old; // time at vflag decision made
} ip_vlbi_file_t;

//int checkheader(ip_vlbi_file_t *S)
//{
       /* Read 64bit Data header check to get sampling parameters */
//       int iok, i;
//
//       S->bytesread = fread( S->bit64, sizeof( char ), 8, S->stream );
//       //printf("bytes read 1 %d\n",bytesread); //debug
//
//       if( ferror( S->stream ) || S->bytesread==0 )
//       {
//           printf("checkheader: File EOF or Read Error!\n");
//	       i=fclose( S->stream ) ;
//		   return -1;
//	   }
//
//
//       headerchkn(S->bit64,&iok,&S->spatn,&S->adbit,&S->sfreq,&S->numch,
//                        &S->seconds,&S->hh,&S->mm,&S->ss);
//       if (iok == 0)   // sync detection
//	   {
//          printf("New Format (header 64bits) Sync Detected!!\n");
//		  printf("File : %s\n",S->fname);
//          printf("  A/D(bits) = %d  # of ch = %d  Sampling Freq(kHz) = %d\n",
//                    S->adbit,S->numch, S->sfreq);
//          printf("  Time %02d:%02d:%02d   Sec in Day = %d\n",
//                    S->hh,S->mm,S->ss,S->seconds);
//          S->icnt=0;          
//          return 0;
//	   }
//       else
//       {
//           printf("First 64bit is not header block!\n");
//	       i=fclose( S->stream ) ;
//           return -1;
//       }
//}


int checkheader(ip_vlbi_file_t *S)
{
       /* Read 64bit Data header check to get sampling parameters */
    /*
       if first 64bit data is not header block, found header block automatically
       return value > 0 means above condition occurred
    */
      
       int iok, i, n, i32;
       //fpos_t save;
       i32=0;

       S->vflag_old=S->vflag;                  // keep current valid flag
       S->dtime_vflag_old=S->dtime_vflag;  //keep time when vflag decesion made
       S->vflag=0;
       S->bytesread = fread( S->bit32, sizeof( char ), 4, S->stream );
       if( ferror( S->stream ) || S->bytesread==0 )
       {
           printf("checkheader: File EOF or Read Error! (%s)\n",S->fname);
	       i=fclose( S->stream ) ;
		   i32=-1;
           goto exit_loop;
	   }
       for (n=0; n<4; n++){
           S->bit64[n]=S->bit32[n];
       }

loop1:

       S->bytesread = fread( S->bit32, sizeof( char ), 4, S->stream );
       if( ferror( S->stream ) || S->bytesread==0 )
       {
           printf("checkheader: File EOF or Read Error! (%s)\n",S->fname);
	       i=fclose( S->stream ) ;
		   i32=-1;
           goto exit_loop;
	   }
       for (n=0; n<4; n++){
           S->bit64[n+4]=S->bit32[n];
       }
       headerchkn(S->bit64,&iok,&S->spatn,&S->adbit,&S->sfreq,&S->numch,
                        &S->seconds,&S->hh,&S->mm,&S->ss);
       if (iok == 0)   // sync detection
	   {
          if(i32 !=0) printf("  found after %d bits read!\n",i32*32);
          printf("checkheader: Header (64bits) Sync Detected!!\n");
		  printf("checkheader:   File : %s\n",S->fname);
          printf("checkheader:   A/D(bits) %d  CHs %d  SFreq(kHz) %d",
                    S->adbit,S->numch, S->sfreq);
          printf("  Time %02d:%02d:%02d  sec %d\n",
                    S->hh,S->mm,S->ss,S->seconds);
          S->format=1;          
          goto exit_loop;
	   }
       else
       {
           if(i32 ==0) {
               printf("checkheader: First 64bit is not header block!\n");
               printf("checkheader:   Data file name (%s)\n",S->fname);
               printf("checkheader:   searching header.....");
           }
           /* search sync pattern by shifting read position by 32 bits forward */
           for (n=0; n<4; n++){
               S->bit64[n]=S->bit64[n+4];
           }
           i32++;
       }
       goto loop1;
exit_loop:
       if(i32 == 0) S->vflag=1;
       S->dtime_vflag=S->seconds;
       //printf("checkheader:   vflag     dtime_vflag     %d %d\n",S->vflag,S->dtime_vflag);
       //printf("checkheader:   vflag_old dtime_vflag_old %d %d\n",S->vflag_old,S->dtime_vflag_old);
       return i32;
}

int fwdNsec(unsigned char* ibuf, int nsec, int numb, int imax,ip_vlbi_file_t *dat)
{
    int n, i;
    if(nsec <= 0) return 0;
	//printf("fwdNsec: nsec, numb, imax %d %d %d\n",nsec,numb,imax); //debug
    for(n=0; n<nsec; n++)
    {
        for(i=0; i< imax; i++)
        {
            dat->bytesread = fread( ibuf, sizeof( char ), numb, dat->stream );
            //printf("i, bytesread %d %d %d\n",i,dat->bytesread,ferror( dat->stream ));
            if( ferror( dat->stream ) || dat->bytesread==0 ){
		        return -1;
            }
		}
        if(checkheader(&(*dat)) < 0){
             return -1;
        }
     }
     return 0;
}

void plotspe_a(float *spow, int npos, int sfreq, int adbit, char *lab, char *lab2, int mode, 
               double f1khz, double f2khz, float *pmaxdat, float *fdatmax, int nmax)
/*
        mode = 0; log frequency scale   1; linear frequency scale
*/
{
      float cofst, fmaxkhz, fminkhz, fsampl, df, ymax, ymin, pmax, pmin, maxdbm, mindbm;
      float *fdat, *powdat;
      float x,y;
      float fatmax;
      char htitl[60], xtit[60], ytit[60];
      int n, npmax,k, ncount,nmaxpos,i;
      //float pmaxdat[4],fdatmax[4];
	  //nmax=4;
      strcpy(htitl,"POWER SPECTRUM");

      /* frequency axis generation */

      npmax=npos/2;

      fdat   = (float *)malloc(npmax*sizeof(float));
      powdat = (float *)malloc(npmax*sizeof(float));

      fsampl=1000.0*(float)sfreq;
      df=fsampl/(float)npos;
      if(mode == 0) {    // log scale
         fmaxkhz=log10(fsampl/2000.0);
         fminkhz=log10(df/1000.0);
         for(n=0; n<npmax; n++){fdat[n]=log10((float)n*df/1000.0); }
      } else {          //  linear scale
         fmaxkhz=fsampl/2000.0;
         fminkhz=0.0;
         //fmaxkhz=990.0;
         //fminkhz=920.0;
      	 if(f1khz != 0.0) fminkhz=(float)f1khz;
      	 if(f2khz != 0.0) fmaxkhz=(float)f2khz;
         for(n=0; n<npmax; n++) fdat[n]=(float)n*df/1000.0; 
      }

      strcpy(xtit,"FREQUENCY (kHz)");
      strcpy(ytit,"POWER (dBm)");
      if( adbit==1 ){strcpy(ytit,"POWER (dB)"); }
      ymax=10.0;
      ymin=-80.0;
      //ymax=-34.0;
      //ymin=-40.0;
      if (adbit == 8 ){ ymin=-100; }    // extend dynamic range 

      /* data max, min check */
	  //printf("max search start %d\n",npmax);
	  
	  for(n=0; n<npmax; n++) powdat[n]=spow[n];
	
      pmin= 1.0e30;
	  for(ncount=0; ncount<nmax; ncount++){
          pmax=-1.0e30;
		  k=0;
		  for(n=0; n<npmax; n++){
            if(fdat[n]>=fminkhz && fdat[n]<=fmaxkhz){
               if(powdat[n] > pmax){ 
                   pmax=powdat[n];
                   fatmax=fdat[n];
               	   pmaxdat[ncount]=pmax;
               	   fdatmax[ncount]=fatmax;
               	   nmaxpos=n;
               }
           	   if(ncount==0) {
           		    if(powdat[n] < pmin) pmin=powdat[n]; 
           	   }
               k++;
           	}
          }
		 powdat[nmaxpos]=-10.0e30;
	  	 //printf("pmax,fatmax, i %f %f %d\n",pmax,fatmax,i);
      }
	 /*
      printf("Number of points = %d\n",k);
      printf("1st Max %fdbm at %fkHz\n",pmaxdat[0],fdatmax[0]);
      printf("2nd Max %fdbm at %fkHz\n",pmaxdat[1],fdatmax[1]);
      printf("3rd Max %fdbm at %fkHz\n",pmaxdat[2],fdatmax[2]);
      printf("4th Max %fdbm at %fkHz\n",pmaxdat[3],fdatmax[3]);
	 */
      maxdbm=pmaxdat[0];
      mindbm=pmin;
      ymax=pmaxdat[0];
      ymin=pmin;
	  //printf("ymax,ymin %f %f\n",ymax,ymin);
	
	  for(n=0; n<npmax; n++) powdat[n]=spow[n];
      //goto exitend; //debug

      /* open graphics device */
      /*   move to main */
       //if (cpgopen("?") < 1)
      // if (cpgopen("/GF") < 1)
      // {
      //    goto exitend;
      // }

      cpgsch(2.0);  // set text height 2.0  (default is 1)
      cpgslw(2);    // set line width

      /* define coordinate range of graph */
      if(mode == 0){   
         cpgenv(fminkhz, fmaxkhz, ymin, ymax, 0, 10);   // log scale
      } else {         
         cpgenv(fminkhz, fmaxkhz, ymin, ymax, 0, 0);   // linear scale
      }
      
      /* label the axes */
       cpglab(xtit,ytit,htitl);

      /* sub label write*/
       cpgsch(1.5);
       cpgmtxt("T",1.5,0.5,0.5,lab);
       cpgmtxt("T",0.5,0.5,0.5,lab2);
       cpgsch(2.0);
      
      /* check data */
      if (pmax == pmin)
      {
          cpgmtxt("B",-6.0,0.5,0.5,"NO TIME VARIABLE");
          cpgmtxt("B",-4.0,0.5,0.5,"COMPONENT FOUND");
          /* label the axes */
          
      }
      else
      {


          /* plot the line graph */
          fdat[0]=fdat[1];
          powdat[0]=powdat[1];  // to avoid ugry plot
          //cpgslw(1);    // set line width
          cpgline(npmax,fdat,powdat); 

      }
      /* close the graphics device */
      /* move to main */
      //cpgclos();
  exitend: 
     free(powdat);
     free(fdat);
}

void plotautocor(float *spow, int npos, int sfreq, int adbit, char *lab, char *lab2, int amode)
/*
        mode = 0; log frequency scale   1; linear frequency scale
*/
{
      float cofst,tmax, tmin, fsampl, dt, ymax, ymin, pmax, pmin, maxdbm, mindbm;
      float *tdat, *pdat;
      float x,y;
      char htitl[60], xtit[60], ytit[60];
      int n, k, npmax, nhalf;

      strcpy(htitl,"AUTO CORRELATION (ABS)");

      /* time axis generation */

      if(amode <= 1) {
         npmax=npos;
      } else {
         npmax=amode;
      }
      tdat = (float *)malloc(npmax*sizeof(float));
      pdat = (float *)malloc(npmax*sizeof(float));
      nhalf=npmax/2;

      fsampl=1000.0*(float)sfreq;
      dt=1.0/fsampl;
      for(n=0; n<npmax; n++){
          tdat[n]=(float)(n-nhalf)*dt*1.0e6;   // usec unit
      }
      tmax=tdat[npmax-1];
      tmin=tdat[0];

      strcpy(xtit,"DELAY TIME (us)");
      strcpy(ytit,"CORRELATION AMP");
      ymax=1.1;
      ymin=0.0;

      /* data range limited copy and max, min check */
     
      for(n=0; n<npmax; n++)
      {
         k=n-nhalf;
         if(k < 0) k=npos+k;
         pdat[n]=spow[k];
         if(pdat[n]<0) pdat[n]=-pdat[n];  // to take absolute value
         if(n==0)
         {
            pmax=pdat[n];
            pmin=pdat[n];
         }
         else
         {
            if(pdat[n] > pmax){ pmax=pdat[n]; }
            if(pdat[n] < pmin){ pmin=pdat[n]; }
         }
      }
      

      cpgsch(2.0);  // set text height 2.0  (default is 1)
      cpgslw(2);    // set line width

      /* define coordinate range of graph */
      cpgenv(tmin, tmax, ymin, ymax, 0, 0);   // linear scale
      
      /* label the axes */
       cpglab(xtit,ytit,htitl);

      /* sub label write*/
       cpgsch(1.5);
       cpgmtxt("T",1.5,0.5,0.5,lab);
       cpgmtxt("T",0.5,0.5,0.5,lab2);
       cpgsch(2.0);
      /* check data */
      if (pmax == pmin)
      {
          cpgmtxt("B",-6.0,0.5,0.5,"NO DATA FOR PLOT");
          
      }
      else
      {
      
        /* plot the line graph */
         cpgline(npmax,tdat,pdat); 
      }

      /* move to main */
  exitend: 
     free(pdat);
     free(tdat);
}


int main(int argc, char *argv[])
{
       int spatn, sfreq, adbit, numch, kpos;
       int sfreqt,adbitt,numcht;
       int amode;    // >0 auto correlation plot mode 
       long int seconds;
       long int startsec,startsecdata;
       long int startoffset; // start time offset in sec
       int hh, mm, ss;
       int nloop,nloop1,sekibun,sekibun1,sekibun1st,npmax;
       int i,iok, imax, m, k, n, kaisu;
       int smode,usampl,nfft,kplot;
       unsigned char bit64[8];
       unsigned char *ibuf;
       int nbyte=5000;
       FILE *stream;
       fpos_t pos;
       int bytesread;
       int bits, bytes, numb;
       //int mode=0;   // log frequency scale
       //int mode=1;   // linear frequency scale
       int mode, pmode; 
       int scount[4];
	   int nsecs;
       float fsampl,tsampl,fact;
	   double f1khz,f2khz;
       int *idata;
       double *cdata;
       float *xdata, *ydata, *fdat;
       double sum,dc;
       float pows, *spows;
       float pmax,pmin,pmaxdbm,pmindbm,cofst,df;
       char fname[60];
       char timelab[30];
       char lab[60], lab2[60], iplab[40], ltime1st[60];
       char cbuf[60];
       char labfsampl[10];
       //char outfile[] = "./tds.data";
	   char* dflt_fname="tds.data";
       float pmaxdat[4],fdatmax[4];
	   int nmax=4;
       ip_vlbi_file_t X;

	   if(argc == 1){
          printf("Usage: speana2 filename [smode [sekibun1 [sekibun [soffset [comment [f1khz [f2khz]]]]]]]\n");
          printf("\n");
          printf("         where  filename ---- Data file name\n");
          printf("                              if 0 is given, tds.data will be used\n");
          printf("                smode -------- process mode\n");
          printf("                              =0 : 4096 points FFT (default)\n");
          printf("                                   (about 1 kHz resolution @4MHz sampling)\n");
          printf("                              =1 : 4194304 points FFT (about 1Hz resolution)\n");
          printf("                sekibun1 --- unit Averaging period (integer seconds)\n");
          printf("                             default is 1\n");
          printf("                sekibun ---- total averaging period\n");
          printf("                             -VE means repeating period\n");
          printf("                             default is 300\n");
          printf("                soffset --- Start time offset in sec (integer seconds)\n");
          printf("                             default is 0\n");
          printf("                comment --- Comment appeared on a graph\n");
          printf("                            if omitted, you will be asked later.\n");
          printf("                f1khz   ----  serach frequency range (lower boundary) (kHz)\n");
          printf("                              for power Maximum (default is 0)\n");
          printf("                f2khz   ----  serach frequency range (upper boundary) (kHz)\n");
          printf("                              for power Maximum (default is video frequency)\n");
		  exit(0);
	   }

       strcpy(fname,*(argv+1));
	   if (fname[0]=='0'){
          strcpy(fname,dflt_fname);
	   }
       X.fname=fname;
	
	   if (argc>=3){
	      smode = atoi(*(argv + 2 ));
	   } else {
		  smode=0;
       }

	   if (argc>=4){
	      sekibun1 = atoi(*(argv + 3 ));
	   } else {
          sekibun1=1;     // default unit integration time (sec)
       }

	   if (argc>=5){
	      sekibun = atoi(*(argv + 4 ));
	   } else {
          sekibun=300;     
       }

	   if (argc>=6){
	      startoffset = (long int)atoi(*(argv + 5 ));
	   } else {
          startoffset=0;     // default startoffset
       }

       printf("Data File is %s\n",fname);
	   if( (X.stream  = fopen( X.fname, "rb" )) == NULL ){
          //perror( "̓t@CJ܂" );
          //exit( 1 );
	      // return -1;
          printf("File Open Error! \n");
		  goto exitend2;
       }

        /* get comment */

	   if (argc>=7){
          strcpy(iplab,*(argv+6));
       } else {
          /* enter board ID */
          /*
          printf("Enter IP-VLBI BOARD ID -> ");
          read1line(iplab);      // 1 line read from stdin
          printf("Board ID is %s\n",iplab);      
          strcpy(lab2,"IP-VLBI Board ID : ");
          strcat(lab2,iplab);
          */

          /* enter any comment */

          printf("Enter any comment -> ");
          read1line(iplab);      // 1 line read from stdin
          //printf("Board ID is %s\n",iplab);      
          //strcat(lab2,iplab);
       }
	
	   if (argc>=8){
	      f1khz = atof(*(argv + 7 ));
	   } else {
	   	  f1khz=0.0;
	   }
	   if (argc>=9){
	   	  f2khz = atof(*(argv + 8 ));
	   } else {
	   	  f2khz=0.0;
	   }
	printf("f1khz,f2khz %f %f\n",f1khz,f2khz);
       /* Data header check to get sampling parameters */
       if(checkheader(&X) < 0){
            goto exitend;
       }
		
	
	   amode=0; mode=1;   // lenear scale and spectrum mode
	   pmode=0;

nextstep:

       /* parameter set */
        sfreq=X.sfreq;
        adbit=X.adbit;
        numch=X.numch;
        fsampl=1000.0*(float)sfreq;   // sampling frequency (Hz)
        tsampl=1.0/fsampl;            // sampling period (sec)
        bits=((long)fsampl)*adbit*numch;  // # of bits in 1 sec data except header
        bytes=bits/8;                     // # of bytes in 1 sec data except header
        X.fsample=fsampl;
        //sekibun=1;                       // Averaging period for Spectrum (sec)

        //smode=1;                         // low resolution mode

	    usampl=4000;
        //if(smode ==1){ usampl=10000; }
        if(smode ==1) usampl=4000000; 
    //    else {
    //       usampl=50000;
    //       if(sfreq == 40){ usampl=40000; }
    //       if(sfreq == 100){ usampl=100000; }
    //       if(sfreq == 200){ usampl=200000; }
    //    }
        imax=(sfreq*1000)/usampl;
        numb=usampl*adbit*numch/8;   // # of bytes in unit # of samples

        printf("imax numb  %d %d\n",imax,numb);    //debug

    //    nfft=1024;
    //    if(usampl < 524288){nfft= 524288;}
    //    if(usampl < 262144){nfft= 262144;}
    //    if(usampl < 131072){nfft= 131072;}
    //    if(usampl < 65536){nfft= 65536;}
    //    if(usampl < 32768){nfft= 32768;}
    //    if(usampl < 16384){nfft= 16384;}
        nfft=4096;
	    if(smode==1) nfft=4194304;
	
	printf("usampl,nfft %d %d\n",usampl,nfft);
        ibuf = (unsigned char *)malloc(numb);
        idata = (int *)malloc(4*usampl*sizeof(int));
        cdata = (double *)malloc(2*nfft*sizeof(double));
        spows = (float *)malloc(4*nfft*sizeof(float));
        xdata = (float *)malloc(nfft*sizeof(float));
        ydata = (float *)malloc(nfft*sizeof(float));
        npmax=nfft/2;

        fdat   = (float *)malloc(npmax*sizeof(float));
        //autocor=(float *)malloc(4*nfft*sizeof(float));
        df=fsampl/(float)nfft;
        for(n=0; n<npmax; n++) fdat[n]=(float)n*df/1000.0; 
      

        fact=((float)usampl)*((float)usampl);
        
        /* sampling frequency in text for print */
        if(sfreq == 40){strcpy(labfsampl,"40kHz"); }
        if(sfreq == 100){strcpy(labfsampl,"100kHz"); }
        if(sfreq == 200){strcpy(labfsampl,"200kHz"); }
        if(sfreq == 500){strcpy(labfsampl,"500kHz"); }
        if(sfreq == 1000){strcpy(labfsampl,"1MHz"); }
        if(sfreq == 2000){strcpy(labfsampl,"2MHz"); }
        if(sfreq == 4000){strcpy(labfsampl,"4MHz"); }
        if(sfreq == 8000){strcpy(labfsampl,"8MHz"); }
        if(sfreq == 18000){strcpy(labfsampl,"16MHz"); }


       /* foward startffset seconds */
       if(fwdNsec(ibuf, startoffset, numb, imax, &X) <0){
              goto exitend;
       }


        printf("  Time %02d:%02d:%02d   Sec in Day = %d\n",X.hh,X.mm,X.ss,X.seconds);
        sprintf(ltime1st,"Time(UT) %02d:%02d:%02d\0",X.hh,X.mm,X.ss);
        strcpy(lab2,ltime1st);
        strcat(lab2,"  ");
        strcat(lab2,iplab);
        
	    if( (stream  = fopen( "speana2.txt", "w" )) == NULL ){
            //perror( "̓t@CJ܂" );
            //exit( 1 );
	        // return -1;
            printf("File Open Error! \n");
		    goto exitend2;
        }

	   //sekibun1=30;
	   //sekibun1=1;
	   nloop1=0;
	
	   fprintf(stream,"%d %d %d\n", nfft, sfreq, adbit);
	   fprintf(stream,"%d %d\n",sekibun1,sekibun);
	
	nloop=0;  //  sekibun (sec)
	   sekibun1st=1;
loop_main:
        for(k=0; k<4*nfft; k++){spows[k]=0.0;}
        for(k=0; k<4; k++){scount[k]=0;}
loop1:
        if(nloop >0) {
           if(checkheader(&X) < 0){ goto exitend; }
            printf("  Time %02d:%02d:%02d   Sec in Day = %d\n",X.hh,X.mm,X.ss,X.seconds);
        }
    	if(sekibun1st==1){
        	sprintf(ltime1st,"Time(UT) %02d:%02d:%02d\0",X.hh,X.mm,X.ss);
            strcpy(lab2,ltime1st);
            strcat(lab2,"  ");
            strcat(lab2,iplab);
            sekibun1st=0;
	    }
        for(i=0; i< imax; i++){
             bytesread = fread( ibuf, sizeof( char ), numb, X.stream );
        	if(bytesread <= 0) goto exitend;
             //printf("bytes read 2 %d\n",bytesread); //debug
             parseADdata_2(ibuf,numb,adbit,idata, &kpos);
             //printf("numb adbit kpos %d %d %d\n",numb,adbit,kpos); //debug
             //printf("ibuf %d %d %d %d\n",ibuf[0],ibuf[1],ibuf[2],ibuf[3]); //debug
             //printf("idata %d %d %d %d\n",idata[0],idata[1],idata[2],idata[3]); //debug
             //for(k=0; k<kpos; k++){printf("k idata %d %d\n",k,idata[k]);} // debug
             for(m=0; m<numch; m++){
                kaisu=0;
                sum=0.0;
                for(k=0; k<2*nfft; k++)  cdata[k]=0.0; // initialize
             	for(k=0; k<kpos/numch; k++) {
                   //if(m==0){printf("k idata %d %d\n",k,idata[k*numch+m]);} //debug
                   cdata[2*k]=(double)idata[k*numch+m];        
                   // cdata[2*k+1]=0.0;  
                   sum=sum+cdata[2*k];
                   kaisu++;
                }
             
                dc=sum/(double)kaisu;    // DC component
     
                //printf("m DC = %d %f\n",m,dc);  //debug
                
             	for(k=0; k<kpos/numch; k++) {
                   //if(m==0){printf("cdata %f",cdata[2*k]);} //debug
                   cdata[2*k]-=dc;
                   //if(m==0){printf(" %f",cdata[2*k]);} //debug
                }
                //hanning(cdata,nfft);  // hanning filter
                //cdft(2*nfft,-1,cdata);
                if(amode ==0) {    // spectrum mode
                    hanning(cdata,usampl);  // hanning filter
                    cdft(2*nfft,1,cdata);
                } else {
                    cdft(2*nfft,-1,cdata);
                }
             	for(k=0; k<nfft; k++) {
             		pows=(float)((cdata[2*k]*cdata[2*k]+cdata[2*k+1]*cdata[2*k+1])/(double)fact);
                    spows[k*4+m]=spows[k*4+m]+pows;
                }

                scount[m]++;
             }
       }
       nloop++;
       nloop1++;
       if(nloop1 < sekibun1) goto loop1;
	   nloop1=0;

       if(amode > 0) {   // auto correlation function calc
          for(m=0; m<numch; m++){
             for(k=0; k<nfft; k++){
                spows[k*4+m]/=scount[m]; // nomalization
                cdata[2*k]=spows[k*4+m];
                cdata[2*k+1]=0.0;
             }
             if(m==1 || m==3) cdata[0]=1.0;  // to avoid math error
             cdft(2*nfft,1,cdata);
             for(k=0; k<nfft; k++){
               // if(k<10) printf("%d %e\n",k,cdata[2*k]);  // debug
               // if(k>nfft-10) printf("%d %e\n",k,cdata[2*k]);  // debug
                if(k==0) pmax=cdata[0];
                if(cdata[2*k] > pmax) pmax=cdata[2*k];
                spows[k*4+m]=cdata[2*k];
             }
             for(k=0; k<nfft; k++){  // normalize
                spows[k*4+m]/=pmax;
               // if(k<10) printf("   %d %e\n",k,spows[k*4+m]);  // debug
               // if(k>nfft-10) printf("   %d %e\n",k,spows[k*4+m]);  // debug
             }
             
          }
         
       } else {



       	/* convert power to dB  then dBm */       
       	cofst=OFFSET1;       //1 bit sampling full power convert to 0 dB
       	if( adbit==8){cofst=OFFSET8; }    // 8bit sampling offset
       	if( adbit==4){cofst=OFFSET4; }    // 4bit sampling offset
       	if( adbit==2){cofst=OFFSET2; }    // 4bit sampling offset


       	for(m=0; m<numch; m++){
          		for(k=0; k<nfft; k++){
              		spows[k*4+m]/=scount[m]; // nomalization
              		spows[k*4+m]=10.0*log10(spows[k*4+m]) + cofst; 
             		if(k==0){
               		 pmaxdbm=spows[k*4+m];
               		 pmindbm=spows[k*4+m];
              	} else {
                	 if(spows[k*4+m] > pmaxdbm) pmaxdbm=spows[k*4+m]; 
                	 if(spows[k*4+m] < pmindbm) pmindbm=spows[k*4+m]; 
              	}
           	}
           	pmax=pmaxdbm-cofst;
           	pmin=pmindbm-cofst;
           	printf("CH# %d: Maximum data (dB, dBm) is %f %f\n", m+1,pmax,pmaxdbm);      
        	}

        }

        /* plot spectrum (or auto cor) POSTSCRIPT OUT and XTERM*/

        for(kplot=0; kplot<2; kplot++)
        {
            if(pmode==1 && kplot==1) goto bypass;
            if(pmode==2 && kplot==0) goto bypass;
            //if (cpgopen("?") < 1)
            if(kplot==0) {
               if (cpgopen("/PS") < 1) goto exitend;
            }
            if(kplot==1) {
               if (cpgopen("/XTERM") < 1) goto exitend;
            }

            cpgsubp(2,2);  // divide plot pannel into 2X2

            for(m=0; m<numch; m++)
            {
                sprintf(lab,"CH#:%1d %1dbit %s sampling, Tavg(sec)=%3d\0",m+1,
                       adbit,labfsampl,sekibun);
                //printf("%s\n",lab);
            	
            	if(kplot==0) fprintf(stream,"%s\n",lab2);
                for(k=0; k<nfft; k++) xdata[k]=spows[k*4+m];
            	
            	if(kplot==0){
            	   for(k=0; k<npmax; k++) {
                	fprintf(stream,"%d %f %f\n",k+1,fdat[k],xdata[k]);
                   }
            	}
                if(amode > 0) {
                     plotautocor(xdata, nfft, sfreq, adbit, lab, lab2, amode);
                } else {
                     plotspe_a(xdata, nfft, sfreq, adbit, lab, lab2, mode, f1khz, f2khz, pmaxdat, fdatmax, nmax);
                	if(kplot==0){
                        printf("1st Max %fdbm at %fkHz\n",pmaxdat[0],fdatmax[0]);
                        printf("2nd Max %fdbm at %fkHz\n",pmaxdat[1],fdatmax[1]);
                        printf("3rd Max %fdbm at %fkHz\n",pmaxdat[2],fdatmax[2]);
                        printf("4th Max %fdbm at %fkHz\n",pmaxdat[3],fdatmax[3]);
                	}
                }

            }
            /* panel undivided to date write */
            cpgsubp(1,1);
            /* date etc write */
            cpgiden();
            /* close the graphics device */
            cpgclos();
            bypass:
        }
	if(nloop < sekibun) {
		sekibun1st=1;
		goto loop_main;
	}
	if(sekibun < 0) {  //  -sekibun is repeating period
	   nsecs=-sekibun-sekibun1-1;  
	   sekibun1st=1;
       /* foward startffset seconds */
		if(nsecs > 0) {  // 1st data are not sync block!! so nsecs = -sekibun-sekibun "-1"
           if(fwdNsec(ibuf, nsecs, numb, imax, &X) <0)  goto exitend;
		} 
		goto loop_main;
    }
 exitend: ;
 	   i=fclose( X.stream ) ;
	   i=fclose(stream); 
       free(ibuf);
       free(cdata);
       free(idata);
       free(spows);
       free(xdata);
       free(ydata);
       free(fdat);

 exitend2: ;

       return 0;
}
