/**************************************************************/
/*                                                            */
/*   Program Name :  timesettk                                */
/*                                                            */
/*      Version:  0.00  2001-08-16                            */
/*                1.00  2002-10-04                            */
/*                                                            */
/*      Copyright (c) 2002 T.Kondo/CRL All Right Reserved     */
/*                                                            */
/**************************************************************/
/*
/*
     Time Set Program  
        gp@  timesettk year month day hour min sec

          QOOPNXQOPTPOPTbɃZbg

              timesettk 2001 9 20 15 10 15

              ^[̃^C~O͎15bƂȂ
              ZbgƁAbԃ{[h̎\܂̂
              mFB

*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/tdsio.h>


int y2k(int yyyy, int mm, int dd);
int sec2hmss(unsigned int sec, int* hh, int* mm, int* ss);

int y2k(int yyyy, int mm, int dd)
{
  int i, sum = 0;
  int month[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30 , 31, 30, 31};

  if(((yyyy % 4 == 0) && (yyyy % 100 != 0)) || (yyyy % 400 == 0))
    month[1] = 29;
  for (i=0; i<mm-1; i++) {
    sum += month[i];
  }
  sum += dd;

  return sum;
}

int sec2hms(unsigned int sec, int* hh, int* mm, int* ss)
{
	//char cbuf[60];
	long int j;
	*hh=sec/3600 ;
    j=sec-*hh*(long)3600;
    *mm=(int)(j/60) ;
	*ss=(int)(j-*mm*(long)60) ;
   // sprintf(cbuf,"%02d:%02d:%02d",hh,mm,ss);
	//cout << cbuf << '\n';
    return 0;
}

int main(int argc, char **argv)
{
	int fd_in,rv;
	unsigned int time,day,sec; // foCXǂݍ񂾌݂̎i[
    unsigned int secold, stat;
	int  yyyy, mm, dd;      // Ԑݒ(timeset)ŗp
	int  h, m, s;           // Ԑݒ(timeset)ŗp
       int counter;
       int i;

	if(argc != 7){
		printf("Usage: timesettk year month day hour min sec\n");
		exit(0);
	}

	fd_in = open("/dev/tds0", O_RDONLY);  //foCX̃I[v
	if (fd_in == -1) {
		perror("device open() error ");
		return -1;
	}
	printf("Device open successd No.[%d]\n",fd_in);
	
       /* board status check */
 	rv = ioctl(fd_in, TDSIO_GET_STATUS, &stat);
	if (rv == -1) {
		perror("ioctl() status get failed ");
		goto end;
	}
	else {
              /* satatus get again just in case */
 	       rv = ioctl(fd_in, TDSIO_GET_STATUS, &stat);
	       if (rv == -1) {
		    perror("ioctl() status get failed ");
		    goto end;
	       }
	       //printf("ioctl() status get succeed\n");
             // printf(" status = %X\n",stat);
              if((stat & 1) != 1){
                  printf("Warning! 10MHz signal is not supplied. \n");
              }
              if((stat & 2) != 2){
                  printf("Warning! 1PPS signal is not supplied. \n");
              }
              if((stat & 3) != 3){
                  printf("Check above signal connection and try again!\n");
                  goto end;
              }
	}
	//foCX玞̎擾
       /*
	rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
	if (rv == -1) {
		perror("ioctl() time get failed ");
		return -1;
	}
	printf("get count day from device [%5d]\n",TDS_GET_DAYS(time));
	printf("get count sec from device [%5d]\n",TDS_GET_SEC(time));
       */

	/* ݒ */
	yyyy = atoi(*(argv + 1 ));
	mm   = atoi(*(argv + 2 ));
	dd   = atoi(*(argv + 3 ));
	h    = atoi(*(argv + 4 ));
	m    = atoi(*(argv + 5 ));
	s    = atoi(*(argv + 6 ));

	printf("%d,%d,%d,%d,%d,%d\n",yyyy,mm,dd,h,m,s);

	day = y2k(yyyy, mm, dd);
	sec = ((h * 60) + m) * 60 + s;
	time = TDS_MAKE_TIME(day,sec);

	printf("All count day [%5d]  \n",day);
	printf("All count sec [%5d]  \n",sec);

	//foCXɎ̃Zbg
	rv = ioctl(fd_in, TDSIO_SET_TIME, &time);  
	if (rv == -1) {
		perror("ioctl() time set failed ");
		return -1;
	}
	//printf("time set ok\n");

	//1b̐ݒ
	rv = ioctl(fd_in, TDSIO_SYNC_1PPS);
	if (rv == -1) {
		perror("ioctl() 1pps sync failed ");
		return -1;
	}
	printf("1pps sync ok\n");

	time = 0; //Ôߏ
       secold=90000;
       counter=0;

	//foCX玞̎擾ă`FbN̂߂PObԃ_Ci~bN\
       do{
	    rv = ioctl(fd_in, TDSIO_GET_TIME, &time);
	    if (rv == -1) {
		perror("ioctl() time get failed ");
		return -1;
	    }
           day=TDS_GET_DAYS(time);
           sec=TDS_GET_SEC(time);
           if (sec!=secold) {
              i=sec2hms(sec,&h,&m,&s);
	       //printf("get count day from device [%5d]\n",TDS_GET_DAYS(time));
	       //printf("get count sec from device [%5d]\n",TDS_GET_SEC(time));
 	       printf("%03d %02d:%02d:%02d\n\033[A",day,h,m,s);
             counter++;
           }
          secold=sec;
       }while(counter <=10);

	printf("\n\n***time setting successd***\n");
end:
	close(fd_in);

}
